<?php if(!function_exists(photoCartIncluded)) { die("Direct file access denied"); } ?>
<?php 
$photo_setup = doSQL("photo_setup", "*", "  ");
require "../setup.php";
$setup['admin_folder'] = "../".$setup['admin_folder'];

if(!empty($_REQUEST['gal_id'])) {
	$_REQUEST['f'] = "EDIT";
	$gal_id = $_REQUEST['gal_id'];
	$pgal = doSQL("galleries", "*", "WHERE gal_id='".$_REQUEST['gal_id']."' ");
} else {
	$_REQUEST['f'] = "NEW";
	$l_num = doSQL("galleries", "*", "ORDER BY gal_order DESC");
	$last = $l_num['gal_order'] + 5;
}

$this_table = "galleries";
$id_name = "gal_id";
$id = "$gal_id";

$new_message = "Adding new gallery.";
$editing_message = "Editing gallery";

$random8 = substr(md5(date('ymdHis')),0,8);

		$gal_under = "".$_REQUEST['gal_under']."";

	$expire  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") + $photo_setup['expire_days'], date("Y")));

	$sv = array(
		array("fn" => "gal_title", "name" => "Gallery Name", "notes" => "Name of the gallery is shown on the website when listing and view gallery.", "size" => "40", "required" => "yes", "ft" => "text", "cols" => "2", "rows" => "4"),

		array("fn" => "gal_under", 
		"name" => "Category", 
		"notes" => "Optional.", 
		"size" => "30", 
		"hide_on_edit" => "yes",
		"edit_mess" => "If you want to move gallery, <A href=\"manage.php?do=photocart&action=galleries&subdo=moveGallery&gal_id=$gal_id\">click here to move gallery</a>",
		"required" => "no", 
		"ft" => "function", 
		"do_function" => "getMultiCats",
		"do_funtion_var" => "cat_under_ids",
		"query" => array("from" => "pc_categories", "where" => "", "order_by" => "ORDER BY cat_name DESC"),
		"q_match" => "gal_under",
		"q_show" => "cat_name",

			),

		array("fn" => "gal_key", "name" => "Access Code", "notes" => "This code is used to gain access to private or public and protected galleries. A random code is given by default but you can change this code at anytime. ", "size" => "12", "required" => "yes", "ft" => "text", "def" => "$random8"),
		
		array("fn" => "gal_date", "name" => "Date", "notes" => "YYYY-MM-DD format", "size" => "20", "required" => "yes", "ft" => "text", "cols" => "2", "rows" => "4", "def"=>"".date('Y-m-d').""),

		array("fn" => "gal_expire", "name" => "Expire Date", "notes" => "<b>YYYY-MM-DD format</b>. This will not automatically delete the gallery, but will show on your \"Expired Galleries\" list. You can set the default amount of days to add in the <a href=\"manage.php?do=photocart&action=settings&subdo=defaults\">Default Settings</a>", "size" => "20", "required" => "no", "ft" => "text", "cols" => "2", "rows" => "4", "def"=>"$expire"),

		array("fn" => "gal_discount", "name" => "Offer early bird discount? (Discount must be set to on. See early bird discount in the sizes & pricing.)", "notes" => "", "required" => "no", "ft" => "radio", "def" => "".$photo_setup['dis_default']."",
		"select_option" => array(array("val" => "1", "name" => "Yes"), 
			array("val" => "2", "name" => "No"),
		),
		),

		array("fn" => "gal_status", "name" => "Status", "notes" => "If status is active, it will be available on the website. Notactive will not be avaialble on the website.", "required" => "yes", "ft" => "radio", "def" => "1",
		"select_option" => array(array("val" => "1", "name" => "Active"), 
			array("val" => "2", "name" => "Not Active"),
		),
		),

		array("fn" => "gal_remove_watermark", "name" => "Remove watermarking", "notes" => "You can remove the watermarking in the flash file for this gallery here.", "required" => "no", "ft" => "radio", "def" => "2",
		"select_option" => array(array("val" => "2", "name" => "No"), 
			array("val" => "1", "name" => "Yes"),
		),
		),


		array("fn" => "gal_pg", 
		"name" => "Price Group", 
		"notes" => "Select a price group for this gallery. If you have not created at least 1 price group, you will need to do so. <a href=\"manage.php?do=photocart&action=sizeprice&subdo=pgedit\">Click here to create a new price group</a>.", 
		"required" => "yes", 
		"def" => "".$photo_setup['default_pg']."",
		"ft" => "select_db", 
		"query" => array("from" => "price_groups", "where" => "", "order_by" => "ORDER BY pg_name ASC"),
		"q_match" => "pg_id",
		"q_show" => "pg_name"),

		array("fn" => "gal_client", "name" => "Type of gallery", "notes" => "Select the access level of this gallery.", "required" => "yes", "ft" => "select", "def" => "".$photo_setup['gal_type']."",
		"select_option" => array(array("val" => "1", "name" => "Private Gallery"), 
			array("val" => "2", "name" => "Public Gallery"),
			array("val" => "3", "name" => "Public Gallery but with access code"),
		),
		),




		array("fn" => "perrow", "name" => "Images per row", "notes" => "", "size" => "3", "required" => "no", "ft" => "text", "def" => "".$photo_setup['perrow'].""),

		array("fn" => "perpage", "name" => "Number of rows", "notes" => "", "size" => "3", "required" => "no", "ft" => "text", "def" => "".$photo_setup['perpage'].""),

		array("fn" => "gal_order", "name" => "Order", "notes" => "The order determines the order the galleries are listed if you choose that option. <a href=\"manage.php?do=photocart&action=settings&subdo=galleryStyle\">Click here for gallery styles</a>. Enter numbers only.", "size" => "3", "required" => "no", "ft" => "text", "def" => "$last"),


		array("fn" => "gal_allow_invite", "name" => "Allow invite to view gallery?", "notes" => "If you select yes, the customers with access to this gallery will be able to invite others to view.", "required" => "yes", "ft" => "radio", "def" => "1",
		"select_option" => array(array("val" => "1", "name" => "Yes"), 
			array("val" => "2", "name" => "No"),
		),
		),

		array("fn" => "gal_style", 
		"name" => "Gallery Template", 
		"notes" => "You can select a different style template for this gallery. Manage templates in the settings menu.", 
		"required" => "no", 
		"sel_val" => "0",
		"ft" => "select_db", 
		"query" => array("from" => "pc_style", "where" => "", "order_by" => "ORDER BY style_name ASC"),
		"q_match" => "style_id",
		"q_show" => "style_name"),


		array("fn" => "gal_descr", "name" => "Description", "notes" => "A description of the gallery shown when viewing.", "def" => "", "required" => "no", "ft" => "textarea", "cols" => "50", "rows" => "6"),
		array("fn" => "gal_expire_to", "name" => "expire to", "notes" => "", "def" => "", "required" => "no", "ft" => "hidden"),

		array("fn" => "id", "name" => "id", "notes" => "", "nosave" => "1", "required" => "no", "ft" => "hidden" , "def" => "$id"),

		array("fn" => "gal_id", "name" => "id", "notes" => "", "nosave" => "1", "required" => "no", "ft" => "hidden" , "def" => "$gal_id"),

	);
// END FORM VARIABLES


function createGalFolder($setup, $_REQUEST, $id) {

			$gal = doSQL("galleries", "*", "WHERE gal_id='$id'");
			if(!empty($gal['gal_under'])) {
				$cat = doSQL("pc_categories", "*", "WHERE cat_id='".$gal['gal_under']."' ");
			}

			$gal_folder = stripslashes(trim(strtolower($gal['gal_title'])));
			$gal_folder = str_replace(" ", "_", $gal_folder);
			$gal_folder = preg_replace("/[^a-z_0-9-]/","", $gal_folder);
			$gal_folder = "$id"."-"."$gal_folder";
			if(!empty($cat['cat_folder'])) {
				$gal_folder = "".$cat['cat_folder']."/$gal_folder";
			}
			if(is_dir("".$setup['path']."/".$setup['gallery_folder']."/$gal_folder")) {
				$gal_folder = ("$gal_folder". "-"."$id"); }

				$sql = "UPDATE galleries SET gal_folder='$gal_folder' WHERE gal_id='$id'";
					if(@mysql_query($sql)) {
					mkdir("".$setup['path']."/".$setup['gallery_folder']."/$gal_folder", 0777);
					chmod("".$setup['path']."/".$setup['gallery_folder']."/$gal_folder", 0777);
					$fp = fopen("".$setup['path']."/".$setup['gallery_folder']."/$gal_folder/index.php", "w");
					$info =  "no access"; 
					fputs($fp, "$info\n");
					fclose($fp);
			} else {
			echo("Error adding > " . mysql_error() . " < that error"); 	}
		return $gal_folder;
		}



if($_REQUEST['check'] == "Submit") {
	$ckey = doSQL("galleries", "*", "WHERE gal_key='".$_REQUEST['gal_key']."' ");
	if(!empty($ckey['gal_id'])) {
		if($ckey['gal_id'] !== $_REQUEST['gal_id']) {
			print "<br><a class=br> That access code is already being used for another gallery. Please change the access code.</a><br>";
			$_REQUEST['check'] = "Preview";
		}
	}
}
		print "<div class=div4>";
		print "<table width=100% cellpadding=2 cellspacing=0 border=0><tr valign=bottom><td width=100%>";
		print "<span class=head>Add / Edit Gallery</span>";
		print "</td></tr><tr><td>";
		print "When you create a new gallery, many variables are set by your default settings. <a href=\"manage.php?do=photocart&action=settings&subdo=defaults\">Click here for your default settings</a>";
		print "</td></tr></table>";
		print "</div>";				

require "".$setup['admin_folder']."/_form.php";

if(($_REQUEST['f'] !== "EDIT") && ($_REQUEST['check'] == "Submit")==true) {
	$gal_folder = createGalFolder($setup, $_REQUEST, $id);
}
	 if($_REQUEST['check'] == "Submit") {

		$title = "Information saved";	
		$success_links = array (
			array("name"=>"View Gallery", "url"=>"$PHP_SELF?do=photocart&action=galleries&gal_id=$id"),
			);
		printSuccessLinks($success_links, $title);
		}





function getMultiCats($fn, $match) {
	print "<select name=\"$fn\">";
	print "<option value=\"0\">Top Level";

	$resultt = @mysql_query("SELECT * FROM pc_categories WHERE cat_under='0' ORDER BY cat_name ASC");
	if (!$resultt) {	echo( "Error perforing query" . mysql_error() . "that error"); 	exit();	}
	while ( $type = mysql_fetch_array($resultt) ) {
	if($type["cat_id"] == $match) { $selected = "selected"; }
	print "<option value=\"".$type["cat_id"]."\" $selected class=fl>--".$type["cat_name"]."";
	unset($selected);
		$parent_id = $type["cat_id"];
			getSubsDrop2($fn, $match, $parent_id, $level, $sec_under);
	}
}

function getSubsDrop2($fn, $match, $parent_id, $level, $sec_under) {
	$level++;
	$subs = @mysql_query("SELECT *  FROM pc_categories WHERE cat_under='$parent_id' ORDER BY cat_name ASC");
	if (!$subs) {	echo( "Error perforing query" . mysql_error() . "that error");	exit(); }
	while($row = mysql_fetch_array($subs)) {
		$sub_sec_id = $row["cat_id"];
		$sub_sec_name = $row["cat_name"];
		$sub_sec_folder = $row["cat_folder"];

		?>
		<option  value="<?php  print "$sub_sec_id"; ?>" <?php  if ($match == $sub_sec_id) { print "selected"; } ?>> <?php  
			while($dashes < $level) {
			print "----";
			$dashes++;
		}
		$dashes = 0;
		print "$sub_sec_name"; 

		$sub2=@mysql_query("SELECT COUNT(*) AS how_many FROM pc_categories WHERE cat_under='$sub_sec_id'");
		if (!$sub2) {	echo( "Error perforing query" . mysql_error() . "that error");	exit(); }
		$row = mysql_fetch_array($sub2);
		$how_many= $row["how_many"];
		if(!empty($how_many)) { 
			$parent_id = $sub_sec_id;
			getSubsDrop2($fn, $match, $parent_id, $level, $sec_under);
		}
	}
		$level = 1;
}


?>