<?php if(!function_exists(photoCartIncluded)) { die("Direct file access denied"); } ?>
<?php
foreach($_REQUEST AS $id => $value) {
	if(!is_array($_REQUEST[$id])) { 
		$req[$id] = addslashes(stripslashes($value));
	} else { 
		$req[$id] = array();
		foreach($_REQUEST[$id] AS $val) { 
			array_push($req[$id],$val);
		}
	}
}
?>



<?php
// Set the required fields in case no javascript:
$req_fields = array("coupon_name" => "Coupon Name","coupon_code" => "Coupon Code","coupon_start" => "Start Date", "coupon_end"=> "Expiration Date", "coupon_amount" => "Coupon Amount");

// Fields we are updating in the database:
$sql_fields[] = "coupon_name";
$sql_fields[] = "coupon_code";
$sql_fields[] = "coupon_end";
$sql_fields[] = "coupon_start";
$sql_fields[] = "coupon_amount";
$sql_fields[] = "coupon_type";
$sql_fields[] = "coupon_min";
$sql_fields[] = "coupon_discount_package";
$sql_fields[] = "coupon_use";
$sql_fields[] = "coupon_status";
$sql_fields[] = "coupon_description";

// Put the fields together for the query
foreach($sql_fields AS  $name) { 
	$t++;
	$add_sql .=" $name='".$req[$name]."' ";
	if($t < count($sql_fields)) {
		$add_sql .= ", ";
	}
}


if(!empty($_REQUEST['submitit'])) { 
	foreach($req_fields AS $id => $name) { 
		if(empty($req[$id])) {
			$error .= "<div>$name is blank</div>";
		}	
	}
	if(!empty($_REQUEST['coupon_id'])) { 
		$ck = doSQL("pc_coupons", "*", "WHERE coupon_code='".$req['coupon_code']."' AND coupon_id!='".$req['coupon_id']."' ");
	} else {
		$ck = doSQL("pc_coupons", "*", "WHERE coupon_code='".$req['coupon_code']."' ");
	}
	if(!empty($ck['coupon_id'])) { 
		$error .= "<div>That coupon code already exists in the system. Please enter a different code.</div>";
	}

	if(!empty($error)) { 
		print "<div class=\"errorMessage\">$error</div>";
	} else {
		if(!empty($_REQUEST['coupon_id'])) { 
			$id = updateSQL("pc_coupons", "$add_sql WHERE coupon_id='".$req['coupon_id']."' ");
		} else { 
			$id = insertSQL("pc_coupons", "$add_sql  ");
		}
		
		$_SESSION['sm'] = "Coupon saved";
		session_write_close();
		header("location: manage.php?do=pricing&action=coupons");
		exit();
	}
} 

?>


<?php printForm();?>



<?php function printForm() { 
	global $setup,$site_setup,$req;
	if((!empty($req['coupon_id']))AND(empty($req['submit']))==true) { 
		$coupon = doSQL("pc_coupons","*", "WHERE coupon_id='".$req['coupon_id']."' ");
		foreach($coupon AS $id => $val) { 
			if(!is_numeric($id)) { 
				$req[$id] = $val;
			}
		}
	}
	if((empty($_REQUEST['coupon_id']))AND(empty($req['submit']))==true) { 
		// Get default values
		$req['coupon_code'] = substr(md5(date('ymdHis')),0,8);
		$req['coupon_start'] = date('Y-m-d');
		$req['coupon_end'] = date('Y-m-d');
		$req['coupon_min'] = "0.00";
	}
	?>

	<form method="post" name="theForm" id="theForm" action="manage.php">
	<div id="roundedForm">
		<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Name for coupon</div>
				<div><input type="text" id="coupon_name" name="coupon_name" size="25" value="<?php  print htmlspecialchars(stripslashes($req['coupon_name']));?>" class="required"></div>
				<div class="fieldDescription">Just a short name for your benefit, only shown in the admin.</div>
			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Coupon Code</div>
				<div><input type="text" id="coupon_code" name="coupon_code" size="25" value="<?php  print htmlspecialchars(stripslashes($req['coupon_code']));?>" class="required"></div>
				<div class="fieldDescription">This is the code the customer will enter to use the coupon. You can change this to what you like.</div>
			</div>

			<div class="clear"></div>
		</div>


		<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Start Date</div>
				<div><input type="text" id="coupon_start" name="coupon_start" size="25" value="<?php  print htmlspecialchars(stripslashes($req['coupon_start']));?>"   class="inputtip required" title="Must be in YYYY-MM-DD format."></div>
				<div class="fieldDescription">When the coupon becomes valid. </div>

			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Expiration Date</div>
				<div><input type="text" id="coupon_end" name="coupon_end" size="25" value="<?php  print htmlspecialchars(stripslashes($req['coupon_end']));?>" class="inputtip required" title="Must be in YYYY-MM-DD format"></div>
				<div class="fieldDescription">The date the coupon expired.</div>

			</div>
			<div class="clear"></div>
		</div>



		<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Discount Amount</div>
				<div><input type="text" id="coupon_amount" name="coupon_amount" size="10" value="<?php  print htmlspecialchars(stripslashes($req['coupon_amount']));?>" class="required"> 
				<select name="coupon_type" id="coupon_type">
				<option value="2" <?php if($req['coupon_type'] == "2") { print "selected"; } ?>>Percentage</option>
				<option value="1" <?php if($req['coupon_type'] == "1") { print "selected"; } ?>>Dollars</option>
				</select>
				</div>
				<div class="fieldDescription">Enter the amount of discount here. If it is $20, then enter 20. If it is going to be a percentage, enter the percentage amount (example: 10%, enter 10)</div>
			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Minimum purchase amount</div>
				<div><input type="text" id="coupon_min" name="coupon_min" size="25" value="<?php  print htmlspecialchars(stripslashes($req['coupon_min']));?>" class="inputtip" title=" Do not use the dollar sign"></div>
				<div class="fieldDescription">An order has to be this amount or more for the coupon can be used (not including tax or shipping).</div>
			</div>
			<div class="clear"></div>
		</div>



	<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">What To Discount</div>
				<div>
				<select name="coupon_discount_package" id="coupon_discount_package">
				<option value="1" <?php if($req['coupon_discount_package'] == "1") { print "selected"; } ?>>Entire order</option>
				<option value="2" <?php if($req['coupon_discount_package'] == "2") { print "selected"; } ?>>Only a la carte pricing</option>
				</select>
				</div>
				<div class="fieldDescription">Select if this coupon will discount the entire order (packages, accessories, etc) or just a la carte pricing (individual prints). This works for percentage discounts. For flat amount discounts, it will check minimum order amount either based on entire order or a la cart pricing.</div>
			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Coupon Usage Limit</div>
				<div>
				<select name="coupon_use" id="coupon_use">
				<option value="1" <?php if($req['coupon_use'] == "1") { print "selected"; } ?>>One use</option>
				<option value="2" <?php if($req['coupon_use'] == "2") { print "selected"; } ?>>No limit</option>
				</select>
				</div>
				<div class="fieldDescription">If this coupon is only good for one customer and to use only one time, select once. Otherwise coupon will be good on all orders that have the coupon code.</div>

			</div>
			<div class="clear"></div>
		</div>


	<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Status</div>
				<div>
				<select name="coupon_status" id="coupon_status">
				<option value="0" <?php if($req['coupon_status'] == "0") { print "selected"; } ?>>Valid</option>
				<option value="1" <?php if($req['coupon_status'] == "1") { print "selected"; } ?>>Used</option>
				</select>
				</div>
				<div class="fieldDescription">If you have a one use coupon and it is used, the status becomes "used" and is no longer avaialble. You can change the status back to good if you are editing this coupon.</div>
			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Description</div>
				<div>
				<textarea name="coupon_description" rows="3" cols="40" class="field100">	<?php  print htmlspecialchars(stripslashes($req['coupon_description']));?></textarea>

				</div>
				<div class="fieldDescription">If you add a description, the description will show on the checkout page after the customer enters the coupon code</div>

			</div>
			<div class="clear"></div>
		</div>

	<div class="row center">
	<input type="hidden" name="do" value="pricing">
	<input type="hidden" name="action" value="coupons">
	<input type="hidden" name="subdo" value="editCoupon">
	<input type="hidden" name="submitit" value="yes">
	<input type="hidden" name="submited" id="submited" value="0">
	<input type="hidden" name="coupon_id" value="<?php print $req['coupon_id'];?>">
	<div id="submitButton">
	<input type="submit" name="submit" id="submit" value="Save Coupon" class="submit" onClick="return checkForm();">
	</div>
	<div id="submitButtonLoading" style="display: none;"><?php print ai_loading;?></div>
	</div>

	</div>
	</form>
<?php } ?>