<?php if(!function_exists(photoCartIncluded)) { die("Direct file access denied"); } ?>
<?php
foreach($_REQUEST AS $id => $value) {
	if(!is_array($_REQUEST[$id])) { 
		$req[$id] = addslashes(stripslashes($value));
	} else { 
		$req[$id] = array();
		foreach($_REQUEST[$id] AS $val) { 
			array_push($req[$id],$val);
		}
	}
}
?>



<?php
// Set the required fields in case no javascript:
$req_fields = array("package_name" => "Package  Name","package_price_type" => "Select pricing");

// Fields we are updating in the database:
$sql_fields[] = "package_name";
$sql_fields[] = "package_type";
$sql_fields[] = "package_price";
$sql_fields[] = "package_no_tax";
$sql_fields[] = "package_add_ship";
$sql_fields[] = "package_download";
$sql_fields[] = "package_discount";
$sql_fields[] = "package_credit";
$sql_fields[] = "package_descr";
$sql_fields[] = "package_price_type";
$sql_fields[] = "package_price_round";



// Put the fields together for the query
foreach($sql_fields AS  $name) { 
	$t++;
	$add_sql .=" $name='".$req[$name]."' ";
	if($t < count($sql_fields)) {
		$add_sql .= ", ";
	}
}


if(!empty($_REQUEST['submitit'])) { 
	foreach($req_fields AS $id => $name) { 
		if(empty($req[$id])) {
			$error .= "<div>$name is blank</div>";
		}	
	}

	if(!empty($error)) { 
		print "<div class=\"errorMessage\">$error</div>";
	} else {
		if(!empty($_REQUEST['package_id'])) { 
			$id = updateSQL("pc_packages", "$add_sql WHERE package_id='".$req['package_id']."' ");
			$id = $req['package_id'];
		} else { 
			$id = insertSQL("pc_packages", "$add_sql  ");
		}
		processSelections();
		$_SESSION['sm'] = "Package saved";
		session_write_close();
		header("location: manage.php?do=packages&viewPackage=$id");
		exit();
	}
} 

?>


<?php printForm();?>



<?php function printForm() { 
	global $setup,$site_setup,$req,$tr;
	if((!empty($req['package_id']))AND(empty($req['submit']))==true) { 
		$package = doSQL("pc_packages","*", "WHERE package_id='".$req['package_id']."' ");
		foreach($package AS $id => $val) { 
			if(!is_numeric($id)) { 
				$req[$id] = $val;
			}
		}
	}
	if((empty($_REQUEST['package_id']))AND(empty($req['submit']))==true) { 
		// Get default values
		$req['package_no_tax'] = 0;
		$req['package_add_ship'] = "0.00";
		$req['package_price_type'] = "perphoto";
	}

	?>

	<form method="post" name="theForm" id="theForm" action="manage.php">

	<div id="roundedForm" style="width: 60%; float: left;">
		<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Package Name</div>
				<div><input type="text" id="package_name" name="package_name" size="25" value="<?php  print htmlspecialchars(stripslashes($req['package_name']));?>" class="required field100"></div>
				<div class="fieldDescription"></div>
			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Download Photos?</div>
				<div>
				<select name="package_download" id="package_download">
				<option value="">Not a download photo</option>
				<option value="original" <?php if($req['package_download'] == "original") { print "selected"; } ?>>Original uploaded photo for download</option>
				<option value="zoom" <?php if($req['package_download'] == "zoom") { print "selected"; } ?>>Zoom / enlarge size photo</option>
				<option value="display" <?php if($req['package_download'] == "display") { print "selected"; } ?>>Display size photo</option>
				</select>
			</div>
				<div class="fieldDescription">If you are wanting this product to be a downloadable photo, select the size above.</div>
			</div>

			<div class="clear"></div>
		</div>


		<div class="row">
			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Additional shipping charge</div>
				<div><?php print $tr['currency'];?><input type="text" id="package_add_ship" name="package_add_ship" size="6" value="<?php  print htmlspecialchars(stripslashes($req['package_add_ship']));?>"></div>
				<div class="fieldDescription">This  will be added TO your regular shipping calculation.</div>

			</div>

			<div style="width: 50%;" class="left">
				<div class="fieldLabel">Is this taxable?</div>
				<div>
				<input type="radio" name="package_no_tax" id="package_no_tax" value="0" <?php if($req['package_no_tax'] == "0") { print "checked"; } ?>> Yes <br>
				<input type="radio" name="package_no_tax" id="package_no_tax" value="1" <?php if($req['package_no_tax'] == "1") { print "checked"; } ?>> No
				</div>
				<div class="fieldDescription"></div>

			</div>
			<div class="clear"></div>
		</div>


	<div class="row">
		<div class="fieldLabel">Offer percentage discount on a la carte pricing</div>
			<div>
			<input type="text" id="package_discount" name="package_discount" size="6" value="<?php  print htmlspecialchars(stripslashes($req['package_discount']));?>">
			</div>
			<div class="fieldDescription">If you would like to offer a discount on a la carte pricing when customer purchases this package, enter the <b>percentage</b> of the discount above. Example, for 20%, enter in 20
	<br><br><b>VERY IMPORTANT: </b>
	<br>* You will want to add information of the discount in the description below so your customers will know about it.</div>
		</div>



	<div class="row">
		<div class="fieldLabel">Description</div>
			<div>
			<textarea name="package_descr" id="package_descr" rows="3" cols="40" class="field100"><?php  print htmlspecialchars(stripslashes($req['package_descr']));?></textarea>
			</div>
			<div class="fieldDescription"></div>
		</div>

	<div class="row center">
	<input type="hidden" name="do" value="packages">
	<input type="hidden" name="action" value="editBuyAllPackage">
	<input type="hidden" name="submitit" value="yes">
	<input type="hidden" name="package_type" value="2">
	<input type="hidden" name="submited" id="submited" value="0">
	<input type="hidden" name="package_id" value="<?php print $req['package_id'];?>">
	<div id="submitButton">
	<input type="submit" name="submit" id="submit" value="Save Package" class="submit" onClick="return checkForm();">
	</div>
	<div id="submitButtonLoading" style="display: none;"><?php print ai_loading;?></div>
	</div>

	</div>

	<div style="width: 37%; float: right;">
	<div class="pc"><h3>Select Pricing</h3></div>
	<div class="pc">There are 2 types of ways you can do pricing for buy all packages. Price per photo in the gallery or create a range of photos in the gallery.</div>
	<div class="pc"><input type="radio" name="package_price_type" id="package_price_type" value="perphoto" onclick="selectPricing('perphoto');" <?php if($req['package_price_type'] == "perphoto") { print "checked"; } ?>> <span class="bold">Price Per Photo</span></div>
	
	<div id="perphotopricing" <?php if($req['package_price_type'] !== "perphoto") { print "style=\"display: none;\""; } ?>>
	<div class="pc">Charge <?php print $tr['currency'];?><input type="text" name="package_price" id="package_price" size="6" value="<?php  print htmlspecialchars(stripslashes($req['package_price']));?>"> for each photo in the gallery.</div>
	<div class="pc"><input type="checkbox" name="package_price_round" value="1" <?php if($req['package_price_round'] == "1") { print "checked"; } ?>> Check this box to round prices. If you enter in a price like <?php print showPrice(2.49);?> and the total for 33 photos is <?php print showPrice(82.17);?>, then it would be rounded and shown as <?php print showPrice(82);?></div>
	<div>&nbsp;</div>
	</div>

	<div class="pc"><input type="radio" name="package_price_type" id="package_price_type" value="range"  onclick="selectPricing('range');" <?php if($req['package_price_type'] == "range") { print "checked"; } ?>> <span class="bold">Range based on total photos in the gallery.</span></div>
	<div id="rangepricing" <?php if($req['package_price_type'] !== "range") { print "style=\"display: none;\""; } ?>>
	<div class="pc">Here you can create a price based on a range of amount of photos in the gallery. For example, you have range of 30-40 photos and a price of $50. The gallery contains 36 photos. It will charge them $50.</div>
	<div class="pc"><a href="javascript:showHide('example');">Show example</a></div>

	<div class="pc" id="example" style="display: none;">
	<div style="width: 50%; float: left;">
	<table cellpadding="4" cellspacing="4">
	<tr>
	<td>QTY From</td><td>QTY To</td><td>Price</td>
	</tr>
	<tr><td>10</td><td>19</td><td><?php print showPrice(20);?></td></tr>
	<tr><td>20</td><td>29</td><td><?php print showPrice(30);?></td></tr>
	<tr><td>30</td><td>39</td><td><?php print showPrice(40);?></td></tr>
	<tr><td>40</td><td>49</td><td><?php print showPrice(50);?></td></tr>
	<tr><td>50</td><td>59</td><td><?php print showPrice(60);?></td></tr>
	<tr><td>60</td><td>69</td><td><?php print showPrice(70);?></td></tr>
	<tr><td>70</td><td>79</td><td><?php print showPrice(80);?></td></tr>
	<tr><td>80</td><td>89</td><td><?php print showPrice(90);?></td></tr>
	<tr><td>90</td><td>99</td><td><?php print showPrice(100);?></td></tr>
	<tr><td>100</td><td>109</td><td><?php print showPrice(110);?></td></tr>
	<tr><td>110</td><td>119</td><td><?php print showPrice(120);?></td></tr>
	<tr><td>120</td><td>129</td><td><?php print showPrice(130);?></td></tr>
	<tr><td>130</td><td>139</td><td><?php print showPrice(140);?></td></tr>
	<tr><td>140</td><td>0</td><td><?php print showPrice(150);?></td></tr>

	</table>
	</div>
	<div style="width: 50%; float: left;">
	<div class="pc">To the left is an example of range pricing. QTY From and To is for the amount of photos in the gallery. </div>
	<div class="pc">In this example, if a gallery contains 62 photos, the price of the package woulf be <?php print showPrice(70);?>. </div>
	<div class="pc">If a gallery contains 28 photos, the price of the package woulf be <?php print showPrice(30);?>. </div>
	<div class="pc">If a gallery contains 163 photos, the price of the package woulf be <?php print showPrice(150);?>. </div>
	<div class="pc">Notice that in the last range, the qty to is 0. This means that is the last one and another above that qty from will be charged that price.</div>
	</div>
	<div class="clear"></div>
	</div>
	<div class="pc">IMPORTANT: <ul>
	<li>Be sure there is no gapping in your ranges. Example: from: 10 to 19 ... the next from has to start at 20. 
	<li>End you last qty to range with a 0.
	<li>Your first qty from will be the minimum for this package to show. So if you start with 20, and the gallery has 15 photos, then the package will not be offered.
	</ul>
	</div>
	<?php print selectForm(); ?>
	<div class="pc">If you need more lines to enter, save package and more will be available.</div>
	</div>

	</div>
	<div class="clear"></div>


	</form>
<?php } ?>
<script>
		function selectPricing(id) { 
		if(id == "perphoto") { 
			$("#perphotopricing").show();
			$("#rangepricing").hide();
		}
		if(id == "range") { 
			$("#perphotopricing").hide();
			$("#rangepricing").show();
		}

	}
</script>



<?php 
function selectForm() {
	global $req,$tr;
	//	$html.= "<li>".$_REQUEST['opt_id']." - ".$_REQUEST['action']."";
	
	if((empty($req['check']))AND(!empty($req['package_id']))==true)  {
		$req['f'] = "EDIT";
		$sels = whileSQL("pc_packages_buy_all", "*", "WHERE ba_package='".$_REQUEST['package_id']."' ORDER BY ba_from ASC ");
		$pcount = 1;
		while($sel = mysql_fetch_array($sels)) {
			$req['ba_from'][$pcount] = $sel['ba_from'];
			$req['ba_to'][$pcount] = $sel['ba_to'];
			$req['ba_price'][$pcount] = $sel['ba_price'];
			$req['ba_order'][$pcount] = $sel['ba_order'];
			if($sel['sel_def'] == "1") {
				$def = $pcount;
			}
			$pcount++;
		}
		$req['pcount'] = $pcount;
	}
	
	$html .= '
	<div class=listbox>
	<table cellpadding=0 cellspacing=0 border=0 align=center width=100%>
	<tr><td class=tdtop> QTY From</td><td class=tdtop>QTY To</td><td class=tdtop>Price</td></tr>
	';

		$lines = $req['pcount'] + 8;
	$ct = 1;
	while($ct<=$lines) {
	if($ct%2) {
		$rowclass= "tdrows1";
	} else {
		$rowclass = "tdrows2";
	}

		$html .= "<tr valign=top><td class=\"$rowclass\"><input type=\"text\" name=\"ba_from[$ct]\" size=\"4\" value=\"".htmlspecialchars(stripslashes($req['ba_from'][$ct]))."\"></td>";
		$html .="<td class=\"$rowclass\"><input type=\"text\" name=\"ba_to[$ct]\" size=\"2\" value=\"".htmlspecialchars(stripslashes($req['ba_to'][$ct]))."\"></td>";
		$html .= "<td class=\"$rowclass\">".$tr['currency']."<input type=\"text\" name=\"ba_price[$ct]\" size=\"6\" value=\"".$req['ba_price'][$ct]."\"></td>";
		$html .= "</tr>";
		 $ct++;
	}
	$html .="<input type=\"hidden\" name=\"pcount\" value=\"".$req['pcount']."\">";

	$html .= "</table></div>";
	return $html;
 } ?>

<?php 
function processSelections() {
	global $req;
	//print "<pre>"; print_r($req); print "</pre>";
	//print "<h1>".$req['package_id']."</h1>";
	if($req['submitit'] == "yes") {
		if(!empty($req['package_id'])) { 
			deleteSQL2("pc_packages_buy_all", "WHERE ba_package='".$req['package_id']."' ");
		}

		foreach($req['ba_from'] AS $id => $opt) {
			$thisCount++;
			print "<li>$opt";
			if(!empty($opt)) {
				$in = insertSQL("pc_packages_buy_all", " ba_from='".$req['ba_from'][$id]."', ba_to='".$req['ba_to'][$id]."', ba_price='".$req['ba_price'][$id]."', ba_order='".$req['ba_order'][$id]."', ba_package='".$req['package_id']."' ");
				unset($and_add);
			}
		}
	}
}
?>