<?php
if(!function_exists(photoCartIncluded)) { die("Direct file access denied"); }
function output_iptc_data( $image_path, $info ) {
$ipinfo = doSQL("pc_iptc", "*", "");

	$iptcTags = array (

		"2#000" => "Record Version",
		"2#005" => "Title",
		"2#025" => "Keywords",
		"2#120" => "Caption",
		"2#003" => "Object Type Reference",
		"2#007" => "Edit Status",
		"2#008" => "Editorial Update",
		"2#010" => "Urgency",
		"2#012" => "Subject Reference",
		"2#015" => "Category",
		"2#020" => "Supplemental Category",
		"2#022" => "Fixture Identifier",
		"2#026" => "Content Location Code",
		"2#027" => "Content Location Name",
		"2#030" => "Release Date",
		"2#035" => "Release Time",
		"2#037" => "Expiration Date",
		"2#035" => "Expiration Time",
		"2#040" => "Special Instructions",
		"2#042" => "Action Advised",
		"2#045" => "Reference Service",
		"2#047" => "Reference Date",
		"2#050" => "Reference Number",
		"2#055" => "Date Created",
		"2#060" => "Time Created",
		"2#062" => "Digital Creation Date",
		"2#063" => "Digital Creation Time",
		"2#065" => "Originating Program",
		"2#070" => "Program Version",
		"2#075" => "Object Cycle",
		"2#080" => "By-Line (Author)",
		"2#085" => "By-Line Title (Author Position) [Not used in Photoshop 7]",
		"2#090" => "City",
		"2#092" => "Sub-Location",
		"2#095" => "Province/State",
		"2#100" => "Country/Primary Location Code",
		"2#101" => "Country/Primary Location Name",
		"2#103" => "Original Transmission Reference",
		"2#105" => "Headline",
		"2#110" => "Credit",
		"2#115" => "Source",
		"2#116" => "Copyright Notice",
		"2#118" => "Contact",
		"2#122" => "Caption Writer/Editor",
		"2#125" => "Rasterized Caption",
		"2#130" => "Image Type",
		"2#131" => "Image Orientation",
		"2#135" => "Language Identifier",
		"2#150" => "Audio Type",
		"2#151" => "Audio Sampling Rate",
		"2#152" => "Audio Sampling Resolution",
		"2#153" => "Audio Duration",
		"2#154" => "Audio Outcue",
		"2#200" => "ObjectData Preview File Format",
		"2#201" => "ObjectData Preview File Format Version",
		"2#202" => "ObjectData Preview Data"

	);
	if((!empty($image_path)) && (empty($info))==true) {
		$size = getimagesize ( $image_path, $info);
	}
		$iptc = iptcparse($info["APP13"]);
//		print "<pre>{{{ IPTC Data }}} : "; print_r($iptc); print "</pre>";
		if(is_array($iptc)) {

			foreach (array_keys($iptc) as $s) {
				$c = count ($iptc[$s]);
				for ($i=0; $i <$c; $i++) {
					$idata[$iptcTags[$s]]= $iptc[$s][$i];
//					 echo '<li> '.$iptcTags[$s].' = '.$iptc[$s][$i].'';
					if($iptcTags[$s] == $ipinfo['title']) {
						$imageData['Title'] = $iptc[$s][$i];
					}
					if($iptcTags[$s] == $ipinfo['text']) {
						$imageData['Caption'] = $iptc[$s][$i];
					}
					if($iptcTags[$s] == $ipinfo['tags']) {
						$imageData['Keywords'] .= ",".$iptc[$s][$i];
					}
					if($iptcTags[$s] == $ipinfo['category']) {
						$imageData['Category'] = $iptc[$s][$i];
					}
					if($iptcTags[$s] == $ipinfo['location']) {
						$imageData['Location'] = $iptc[$s][$i];
					}
					if($iptcTags[$s] == "Date Created") {
						$imageData['Date'] = $iptc[$s][$i];
					}

				}
			}
		}

return $imageData;
}
?>

<?php
function showImageData() {
	global $_REQUEST,$settings, $setup, $entry;

	if(!empty($entry['image_dl'])) {

	}
	$exifList = array("Make", "Model", "DateTime", "ExposureTime", "ISOSpeedRatings", "ImageType", "FNumber", "Orientation", "ApertureValue", "ShutterSpeedValue", "DateTimeOriginal", "ExposureBiasValue", "MaxApertureValue", "MeteringMode", "LightSource", "Flash", "FocalLength");

	print "<table align=center cellpadding=4 cellspacing=0 border=0 class=listbox width=100%>";
	print "<tr><td class=tdrows1>Dimensions</td><td class=tdrows1>".$entry['image_dl_width']." X ".$entry['image_dl_height']."</td></tr>";
	print "<tr><td class=tdrows1>File size</td><td class=tdrows1>".size_hum_read("".$entry['image_dl_size']."")."</td></tr>";


	$exif = @read_exif_data ("".$setup['path']."/".$entry['entry_folder']."/".$entry['image_dl']."");
	foreach($exifList AS $what) {
		if(!empty($exif[$what])) {
			print "<tr><td class=tdrows1>$what</td><td class=tdrows1>".$exif[$what]."</td></tr>";
		}
	}
	print "</table>";
	/*
// while(list($k,$v)=each($exif)) {
	foreach($exif AS $id => $data) {
		if($id!=="MakerNote") {
			if(is_array($data)) {
				print "<li>$id";
				print_r($data);
			} else {
				print "<li>$id : $data";
			}
		}
//   echo "$k: $v<br>\n";

 }

 */
}


?>
