<?php 
include "../setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
ob_start(); 
include "../pc_inc/functions.php"; 
include "../pc_inc/pc_functions.php"; 
$dbcon = dbConnect($setup);
$site_setup = doSQL("pc_settings", "*", "");
$payopt = doSQL("pc_payment_options", "*", "WHERE pay_option='paypalpro' ");
$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
$currency = $site_setup['currency_code'];

/*********************************************************
'
' BEGIN USER CONFIG:
'
'*********************************************************/
	$storename				= $site_setup['website_name'];							// This is the business name that will appear on invoices	
	$sandbox	 			= false;											// true for sandbox, false for live
	$debugging 				= false;										// Enter True if you want to print debug info - False if you don't																														
	$root_url 				= $setup['url']."/payment/"; 			// direct path to module root. dont forget trailing /
	$root_ssl_url 			= $setup['secure_url']."/payment/";			// direct path to module root on SSL server. dont forget trailing /
	
	$doRedirect				= false;										// used for a GET redirect after a transaction, instead of POST.
	
	$redirectPage			= $setup['secure_url']."/payment/example_complete.php";	// when a transaction is completed, this is where we go, whether it was POST or GET.
	$cancel_payment_url		= $setup['secure_url']."/payment/example_cancel.php";		// when a user cancel's a paypal payment, this is the page they will go to
	
	$live_cert_url			= "_paypal_cert_key.txt";							// relative to your module installation
	$live_api_username		= $payopt['pay_num'];
	$live_api_password		= $payopt['pay_key'];
	$live_paypal_email		= $payopt['pay_email'];
	
	$sandbox_cert_url		= "sandbox_cert_key_pem.txt";		// relative to your module installation
	$sandbox_api_username	= $payopt['pay_num'];
	$sandbox_api_password	= $payopt['pay_key'];
	$sandbox_paypal_email	= $payopt['pay_email'];
		
/*********************************************************
'
' END USER CONFIG - DO NOT EDIT ANYTHING BELOW THIS LINE
'
'*********************************************************/

	$live_paypal_site 				= "https://www.paypal.com/";  	
	$sandbox_paypal_site 			= "https://www.sandbox.paypal.com/";
	$live_apiurl			 		= "https://api.paypal.com/2.0/";
	$sandbox_apiurl					= "https://api.sandbox.paypal.com/2.0/";	
		
	if($sandbox)
	{
		$cert_url 		= $sandbox_cert_url;
		$api_username	= $sandbox_api_username;
		$api_password 	= $sandbox_api_password;
		$paypal_email 	= $sandbox_paypal_email;
		$PaypalAPIURL	= $sandbox_apiurl;
		$PaypalSite		= $sandbox_paypal_site;
	}
	else
	{
		$cert_url 		= $live_cert_url;
		$api_username	= $live_api_username;
		$api_password 	= $live_api_password;
		$paypal_email 	= $live_paypal_email;
		$PaypalAPIURL	= $live_apiurl;
		$PaypalSite		= $live_paypal_site;
	}

	session_name("zenat");
	session_start();
	
?>