<?php 
include_once("config.php");
include_once("functions.php");

?>

<script type="text/javascript">

function SubmitForm()
{
	document.myform.submit();
}

</script>

<?php 
	if($sandbox)
	{
		echo '<div style="margin-left:100px;">';
		echo "<b>WARNING:</b> Sandbox Mode is enabled. Payments will not be processed.<br>";
		echo '</div>';
	}
	
	if($debugging)
	{
		echo '<div style="margin-left:100px;">';
		echo "<b>WARNING:</b> Debug Output is enabled.<br><br>";
		echo '</div>';
	}
	
	if (file_exists($cert_url))
	{	  
	  $fp = fopen($cert_url, "r");
	  $file_contents = fread($fp, filesize($cert_url));
	  fclose($fp);
	} 
	else 	
	{
		$displayMsg = "Error: The api certificate does not exist<br>The location that was checked was: " . $cert_url . "<br>";
	}

	$soapData = SOAP_DoDirectPaymentRequest($_POST);
	$response = SendSoapToPayPal($soapData);

	$arr_vals = xml2php($response);
	
	$PaypalResponse = array();
	
	foreach($arr_vals as $name => $value)
	{
		if(is_array($value))
		{			
			foreach($value as $name2 => $value2) 
			{
				if ($name2 == "tag") 
					$tag_value = $value2;
				if ($name2 == "value")
					$PaypalResponse[$tag_value] = $value2;
			}
		}
	}
	
	// MY TESTING ####################################
	print "<li>Success? ".$PaypalResponse['ACK'];
	print "<li>Amount: ".$PaypalResponse['AMOUNT'];
	print "<li>Transaction ID: ".$PaypalResponse['TRANSACTIONID'];
	print "<li>Card Type".$_POST['creditCardType'];
	print "<li>".$PaypalResponse['ACK'];

	if($PaypalResponse['ACK'] == "Success") {
		$order_pay_amount =  $PaypalResponse['AMOUNT'];
		$order_pay_type =  $_POST['creditCardType']; // paypal, credit cart
		$order_pay_ref =  $PaypalResponse['TRANSACTIONID']; // transaction id
		$order_payment_type = ""; // visa, mc
		$order_id =  $_POST['InvoiceID'];
		$order_name =  $_POST['buyerFirstName']." ".$_POST['buyerLastName'];;
		$order_approve_code = $PaypalResponse['CORRELATIONID'];
		include "payment.update.php";

	} else {
	$order= doSQL("pc_orders", "*, date_format(DATE_ADD(order_date, INTERVAL 0 HOUR), '%M %e, %Y ')  AS order_date", "WHERE order_id='".$_POST['InvoiceID']."'" );

	header("location: ".$setup['secure_url']."/index.php?do=photocart&action=payment&error=".urlencode($PaypalResponse['ACK']."<br><br>".$PaypalResponse['SHORTMESSAGE']."<br><br> ".$PaypalResponse['LONGMESSAGE'])."&order=".$order['order_key']." ");
	exit();

	}


	// END MY TESTING ####################################
	
	if($debugging) {
		echo "<pre>";
		echo "<b>Posted Data:</b><br><br>";
		print_r($_POST);
		echo "</pre>";

		echo "<b>Soap Request:</b><br>";
		print_xml($soapData);
		echo "<pre>";
		echo "<b>Paypal Response:</b><br><br>";
		print_r($PaypalResponse);
		echo "</pre>";	
		
		echo "<pre>";
		echo "<b>Paypal Response:</b><br><br>";
		renderXML($soapData);
		echo "</pre>";	
	}
	
	DoRedirect($PaypalResponse);
	
	?>