<?php 
session_start();

include_once("config.php");
include_once("functions.php");

?>

<script type="text/javascript">

function SubmitForm()
{
	document.myform.submit();
}

</script>

<?php 
	if($sandbox)
	{
		echo '<div style="margin-left:100px;">';
		echo "<b>WARNING:</b> Sandbox Mode is enabled. Payments will not be processed.<br>";
		echo '</div>';
	}
	
	if($debugging)
	{
		echo '<div style="margin-left:100px;">';
		echo "<b>WARNING:</b> Debug Output is enabled.<br><br>";
		echo '</div>';
		
		echo "Token: $_GET[Token]<br>";
	}
	
	if (file_exists($cert_url))
	{	  
	  $fp = fopen($cert_url, "r");
	  $file_contents = fread($fp, filesize($cert_url));
	  fclose($fp);
	} 
	else 	
	{
		$displayMsg = "Error: The api certificate does not exist<br>The location that was checked was: " . $cert_url . "<br>";
	}
	
	$token = $_GET["token"];
	$payerid = $_GET["PayerID"];
		
	$soapData = SOAP_DoExpressCheckoutPaymentRequest($token, $payerid);
	$response = SendSoapToPayPal($soapData);

	$arr_vals = xml2php($response);
	
	$PaypalResponse = array();
	
	foreach($arr_vals as $name => $value)
	{
		if(is_array($value))
		{			
			foreach($value as $name2 => $value2) 
			{
				if ($name2 == "tag") 
					$tag_value = $value2;
				if ($name2 == "value")
					$PaypalResponse[$tag_value] = $value2;
			}
		}
	}
	
	
	if($debugging) {
		echo "<b>Soap Request:</b><br>";
		print_xml($soapData);
		echo "<pre>";
		echo "<b>Paypal Response:</b><br><br>";
		print_r($PaypalResponse);
		echo "</pre>";				
	}
	

	print "SESSION: ";
	print"<pre>";
	print_r($_SESSION);
	print "</pre>";

	if($PaypalResponse['ACK'] == "Success") {
		$order_pay_amount =  $PaypalResponse['GROSSAMOUNT'];
		$order_pay_type =  "PayPal ".$PaypalResponse['TRANSACTIONTYPE']." ".$PaypalResponse['PAYMENTTYPE']; // paypal, credit cart
		$order_pay_ref =  $PaypalResponse['TRANSACTIONID']; // transaction id
		$order_payment_type = $PaypalResponse['PAYMENTTYPE']; // visa, mc
		$order_payment_status = $PaypalResponse['PAYMENTSTATUS'];
		$order_id =  $_SESSION['OrderNumber'];
		$order_name =  $_POST['buyerFirstName']." ".$_POST['buyerLastName'];;
		$order_approve_code = $PaypalResponse['CORRELATIONID'];
	include "payment.update.php";

	} else {
	$order= doSQL("pc_orders", "*, date_format(DATE_ADD(order_date, INTERVAL 0 HOUR), '%M %e, %Y ')  AS order_date", "WHERE order_id='".$_SESSION['OrderNumber']."'" );

	header("location: ".$setup['secure_url']."/index.php?do=photocart&action=payment&error=".urlencode($PaypalResponse['ACK']."<br><br>".$PaypalResponse['SHORTMESSAGE']."<br><br> ".$PaypalResponse['LONGMESSAGE'])."&order=".$order['order_key']." ");
	exit();

	}


	DoRedirect($PaypalResponse);

?>