<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
/* Min inclusion */
$dbcon = dbConnect($setup);
$site_setup = doSQL("pc_settings", "*", "");
$use_secure_logins = $site_setup['use_secure_logins'];
securityCheck();
if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
require "pc_icons.php";
if((!empty($_REQUEST['copage']))AND(!is_numeric($_REQUEST['copage']))==true) { 
	die("Error");
}

/* end Min inclusion */
if($text_edit_page!==true) { 
	foreach($_REQUEST AS $id => $value) {
		if(!is_array($value)) { 
			$_REQUEST[$id] = sql_safe("".$value."");
		}
	}
}


if($text_edit_page!==true) { 
	foreach($_POST AS $id => $value) {
		if(!is_array($value)) { 
			$_POST[$id] = sql_safe("".$value."");
		}
	}
}


?>

<?php
if(!empty($_REQUEST['submit'])) {
	if(empty($_REQUEST['coupon_code'])) {
		print "<div class=\"errorMessage\">".$tr['coupon_no_code']."</div>";
	} else {
		$_REQUEST['coupon_code'] = sql_safe(urldecode("".$_REQUEST['coupon_code'].""));
		$coup = doSQL("pc_coupons", "*, date_format(DATE_ADD(coupon_end, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS coupon_end_show", "WHERE ".strtolower(coupon_code)."='".strtolower($_REQUEST['coupon_code'])."' AND coupon_start<=CURDATE() AND coupon_end>=CURDATE() AND coupon_status='0' ");
		if(empty($coup['coupon_id'])) {
			print "<div class=\"errorMessage\">".$tr['co_bad_coupon']."</div>";
		} else {
			if(countIt("pc_cart", "WHERE cart_id>0 AND  ".checkCartSession()." AND cart_coupon>'0' ")>0) {
				print "<div class=\"errorMessage\">".$tr['coupon_already_in_cart']."</div>";
			} else {
				insertSQL("pc_cart", "cart_coupon='".$coup['coupon_id']."', ".checkCartSession()."  ");

				print "<div class=\"successMessage\">".$tr['coupon_added_to_cart']."</div>";
				print "<div class=\"pageContent\">".$tr['co_coupon']." ".$coup['coupon_code'].": ";
				if($coup['coupon_type'] == "1") { print showPrice($coup['coupon_amount']); } 
				if($coup['coupon_type'] == "2") { print $coup['coupon_amount']."%"; } 
				print "</div>";
				print "<div class=\"pageContent\">".nl2br($coup['coupon_description'])."</div>";
				print "<div class=\"pageContent\">".$tr['coupon_expires']." ".$coup['coupon_end_show']."</div>";
				if($coup['coupon_min'] > 0) { 
					print "<div class=\"pageContent\">".$tr['coupon_min_amount']." ".showPrice($coup['coupon_min'])."</div>";
				}
				print "<br>";
			}
				$show_form = "no";
				print "<div class=\"pageContent\" style=\"text-align: center;\">";
				if($_REQUEST['copage'] == "1") { 
					print "<span onClick=\"closeAddCoupon(); return false;\"; style=\"cursor: pointer;\" class=\"submitSmall\">".$tr['co_continue']."</span>";
				} else { 
					print "<span onClick=\"window.open('index.php?do=photocart&action=cart', '_parent');\"; style=\"cursor: pointer;\" class=\"submitSmall\">".$tr['co_continue']."</span>";
				}
				print "</div>";
		}
	}
}
?>
<?php if($show_form!=="no") { ?>
<div style="float: right;"><div class="pageContent"><span onClick="closeAddCoupon(); return false;" style="cursor: pointer;"><?php print icon_close;?></span></div></div>
<div class="pageContent"><h2><?php print showText("co_coupon_title");?></h2></div>
<?php
	if(countIt("pc_cart", "WHERE cart_id>0 AND  ".checkCartSession()." AND cart_coupon>'0' ")>0) {
		print "<div class=\"errorMessage\">".showText("coupon_already_in_cart")."</div>";
} else {
	?>
<form method="post" name="productForm" id="packageForm_<?php print $cart['cart_id'];?>" action="javascript:submitCoupon('coupon_code,submit,copage');" style="margin: 0px; padding: 0px;">
<table align=center cellpadding=4 cellspacing=0 border=0  width=100%>
<tr><td width=100%><?php print showText("co_coupon_text");?></td></tr>
<tr><td><b><?php print showText("co_coupon");?>: </b><input type="text" size="20" name="coupon_code" id="coupon_code" class=textfield  value="">
<input type="hidden" name="ckCoup" value="1">
<input type="hidden" name="copage" id="copage" value="<?php print $_REQUEST['copage'];?>">
</td></tr></table>
<div class="pageContent" style="text-align:center;"><input type="submit" name="submit" id="submit" value="<?php print $tr['submit'];?>" class="submit"></div>
</form>
<?php } ?>
<div>&nbsp;</div>
<div class="pageContent" style="text-align: center;"><span onClick="closeAddCoupon(); return false;" style="cursor: pointer;"><?php print showText('_cancel_product_view_');?></span></div>
<?php } ?>

<div>&nbsp;</div>

<?php
	if((trim($_SESSION['pc_admin_login']) == "1") AND ($_SESSION['pc_admin'] !== NULL ) AND($_SESSION['editText'] == "1")==true) { ?>
	<hr>
	<div>Coupon added to cart <br><?php print showText("coupon_added_to_cart");?></div>
	<div>&nbsp;</div>

	<?php } ?>
