<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
include $setup['path']."/pc_inc/product_functions.php"; 
include $setup['path']."/pc_inc/packages_functions.php"; 
include $setup['path']."/pc_inc/gallery_image_functions.php"; 
/* Min inclusion */
$dbcon = dbConnect($setup);
$site_setup = doSQL("pc_settings", "*", "");
$use_secure_logins = $site_setup['use_secure_logins'];
unset($_SESSION['color']);
unset($_SESSION['spID']);
securityCheck();
foreach($_REQUEST AS $id => $value) {
	$_REQUEST[$id] = addslashes(stripslashes(strip_tags($value)));
	$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
}

if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
if($_SESSION['pc_client_id'] > 0) {
	$client = doSQL("pc_clients", "*", "WHERE client_id='".$_SESSION['pc_client_id']."' ");
}
require "pc_icons.php";
/* end Min inclusion */
?>
<div id="optionhovercontainer" class="hovercontainer"></div>
<?php
/* GET PHOTO PRICE GROUP */

$pic = doSQL("pics  LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*, date_format(DATE_ADD(pic_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS pic_date", " WHERE pic_id='".$_REQUEST['pic_id']."' ");
$_SESSION['lastImage'] = $pic['pic_id'];
$returnval = galleryTree($pic,"pagetitle");
$main_gallery = $returnval[2];
$pic_views = $pic['pic_views']+1;
updateSQL("pics", "pic_views='".$pic_views."', pic_last_viewed=NOW() WHERE pic_id='".$pic['pic_id']."' ");

if(empty($main_gallery)) { 
	$toplevelgallery = true;
	$main_gallery = $pic['gal_id']; 
} else {
	$main_gal = doSQL("galleries", "*, date_format(DATE_ADD(gal_expire, INTERVAL 2 HOUR), '%M %e, %Y ')  AS gal_expire_show", "WHERE gal_id='".$main_gallery."' ");
}
if($toplevelgallery == true) {
	$gal_pg = $pic['gal_pg'];
} else {
	$gal_client = $main_gal['gal_client'];
	$gal_invite = $main_gal['gal_allow_invite'];
	if(($pic['gal_pg'] == "0")OR($main_gal['gal_pg']==$pic['gal_pg'])==true) {
		$gal_pg = $main_gal['gal_pg'];
	} elseif($main_gal['gal_pg']!==$pic['gal_pg']) {		
		$gal_pg = $pic['gal_pg'];
	}

}
if(!empty($pic['pic_pg'])) {
	$gal_pg = $pic['pic_pg'];
}
if($client['client_pg'] > 0) {
	$gal_pg = $client['client_pg'];
}
$pg = doSQL("price_groups", "*", "WHERE pg_id='$gal_pg' " );





$gallery = doSQL("galleries", "*", "WHERE gal_id='".$pic['pic_gal']."' ");
	if($gallery['perrow'] > 0) {
		$perRow = $gallery['perrow'];
	} else {
		$perRow = $photo_setup['perrow'];
	}
	if($gallery['perpage'] > 0) {
		$perCols = $gallery['perpage'];
	} else {
		$perCols = $photo_setup['perpage'];
	}
	$per_page = $perCols;
$total_images = countIt("pics", "WHERE pic_gal='".$gallery['gal_id']."' ");
if((countIt("galleries", "WHERE gal_sub_gal='".$gallery['gal_id']."' ") > 0)&&($gallery['gal_sub_gal'] <= 0)==true) { 
	$totals = countGalsImgs($gallery['gal_id']);
	$buy_all_total_images = $totals['images'];
} else { 
	$buy_all_total_images = countIt("pics", "WHERE pic_gal='".$gallery['gal_id']."' ");
}



	if(!empty($_REQUEST['q'])) {
//		print "<div class=\"pageContent\">";
		$ret = gallerySearchQ($main_gallery,"".$gallery['gal_id']."");
//	print "<li>( $main_gallery - ".$gallery['gal_id']." )";

		$total_images = $ret['total_results'];
		$and_q = $ret['and_q'];
		if($_REQUEST['ingals']>0) {
			$pics_where  = $ret['pics_where'];
		}
		$res = str_replace("[TOTAL_IMAGES]", $total_images, $tr['search_results']);
		$res = str_replace("[SEARCH_TERM]", stripslashes($_REQUEST['q']),$res);
//		print "$res &nbsp;";

//		print " [<a href=\"index.php?do=photocart&viewGallery=".$gallery['gal_id']."#page=1\">".$tr['search_clear']."</a>]";
//		print "</div>";
	}


$ct = 1;
if($_REQUEST['gal_id'] == "none") { 
	$pics_where = "WHERE pic_id>'0' ";
} else { 
	$pics_where = " WHERE pics.pic_gal='".$pic['pic_gal']."' ";
	if(!empty($_REQUEST['q'])) { 
		if($_REQUEST['ingals']>0) {
			$pics_where  = $ret['pics_where'];
		}
	}
}


	
	if(!empty($_REQUEST['q'])) {
		$ret = gallerySearchQ($main_gallery,"".$gallery['gal_id']."");

		$total_images = $ret['total_results'];
		$and_q = $ret['and_q'];
		if($_REQUEST['ingals']>0) {
			$pics_where  = $ret['pics_where'];
		}
		$res = str_replace("[TOTAL_IMAGES]", $total_images, $tr['search_results']);
		$res = str_replace("[SEARCH_TERM]", stripslashes($_REQUEST['q']),$res);
	}

if($_REQUEST['viewGallery'] == "favs") { 
	$mpics = whileSQL("pc_favs, pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*", "WHERE pc_favs.fav_client='".$_SESSION['pc_client_id']."' AND pics.pic_id=pc_favs.fav_pic ORDER BY pics.pic_id ASC ");
} else { 
	$mpics = whileSQL("pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*", "$pics_where $and_q $and_where  ORDER BY pic_order ASC");
}
while($mpic = mysql_fetch_array($mpics)) {
	$count[$ct] = $mpic['pic_id'];
		if($pic['pic_id'] == $mpic['pic_id']) {
			$this_pic = $ct;
		}
	$ct++;
}

$next = $this_pic + 1;
$prev = $this_pic - 1;
if(!empty($count[$prev])) {
	$prevpic = $count[$prev];
	$ppic = doSQL("pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*", "WHERE pic_id='".$prevpic."' ");
	$dsize = @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$ppic['gal_folder']."/".$ppic['pic_pic'].""); 

	?>
	<div id="prevPhotoInfo" pid="<?php print "".$prevpic."";?>" ww="<?php print $dsize[0];?>" hh="<?php print $dsize[1];?>" gid="<?php print $pic['pic_gal'];?>" position="<?php print $prev - 1;?>" spage="<?php print ceil($prev / $per_page);?>"></div>
<?php } else { ?>
<div id="prevPhotoInfo" pid="0"></div>
<?php } ?>
<?php 
$size= @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$gallery['gal_folder'].""."/".$pic['pic_pic'].""); 
$zsize= @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$gallery['gal_folder'].""."/".$pic['pic_zoom'].""); 
?>

<div id="curpage" spage="<?php print ceil($this_pic / $per_page);?>" position="<?php print $this_pic;?>" pg="<?php print $pg['pg_id'];?>" zm="<?php if((!empty($pic['pic_zoom']))&&($zsize[0] > $size[0])==true) { print "1"; } ?>"></div>
<?php 
if(!empty($count[$next])) {
	$nextpic = $count[$next];
	$npic = doSQL("pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*", "WHERE pic_id='".$nextpic."' ");
	$dsize = @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$npic['gal_folder']."/".$npic['pic_pic'].""); 
	?>
	<div id="nextPhotoInfo" pid="<?php print "".$nextpic."";?>" ww="<?php print $dsize[0];?>" hh="<?php print $dsize[1];?>" gid="<?php print $pic['pic_gal'];?>"  position="<?php print $next - 1;?>" spage="<?php print ceil($next / $per_page);?>"><img src="image.php?image=<?php print $nextpic;?>" style="display: none;"></div>

<?php } else { ?>
<div id="nextPhotoInfo" pid="0"></div>
<?php } ?>
<?php 
galStats($main_gallery, $pic);

$page = floor($total_images / $per_page);
$pics_where = "";
?>
<script>
 $(document).ready(function(){
	<?php if(($_SESSION['ipad']!== true)&&($_SESSION['mobile'] !== true)==true) { ?>
 	 mytips(".tip","tooltip");
	 myenlargeoptions(".enlargeoptions","tooltip");
	<?php } ?>
 });
</script>
<?php 
	$img_incart = countIt("pc_cart", "WHERE ".checkCartSession()." AND cart_pic_id='".$pic['pic_id']."' " );
	if($img_incart > 0) {
		$display = "block";
	} else {
		$display = "none";
	}
	?>
<div>&nbsp;</div>



<?php 
if((($_SESSION['pc_client_login'] !== true) ||  ($_SESSION['pc_client_id'] == NULL )) AND ($site_setup['login_status']!=="1")==true) {
	print "<table align=center cellpadding=0 cellspacing=0 border=0 ><tr><td class=cells><span class=cart_bars_table_text>";
	print "<B>".showText("vi_add_images")."</B>";		
	$use_secure_logins = $site_setup['use_secure_logins'];
	if($use_secure_logins == 1) {
		print "<ul><li><a href=\"".$setup['secure_url']."/index.php?do=register\">".showText("vi_create_account")."</a>.";
		print "<li><a href=\"".$setup['secure_url']."/index.php?do=login\">".showText("vi_login")."</a></ul></span>";
	} else {
		print "<ul><li><a href=\"index.php?do=register\">".showText("vi_create_account")."</a>.";
		print "<li><a href=\"index.php?do=login\">".showText("vi_login")."</a></ul></span>";
	}

	print "</td></tr></table>"; 
	} else { 
?>

<!-- <div style="display: <?php print $display;?>;" id="imageInCartLink"><a href="javascript:showImageInCart('<?php print $pic['pic_id'];?>');"><?php print showText("vi_currently_in_cart");?></a></div> -->
<div style="display: none; text-align: left;" id="imageinCartContainer"><div  id="imageinCart"></div></div>
<div id="cartSuccessContainer" style="display: none;"></div>
<div id="postCart" ></div>
<div id="productListContainer">
<div id="productList" <?php if(!empty($_REQUEST['package_id'])) { print "style=\"display: none;\""; } ?>>
<?php

$gal_pg = $pg['pg_id'];
?>

<div id="otherLabels">
<?php 
$show_products = explode("\r\n",$pg['pg_layout']);
foreach($show_products AS $showit) {
	if($showit == "[STANDARD_PRODUCTS]") { showStandardProductsSection(); }
	if($showit == "[PACKAGES]") { showPackagesSection(); }
	if($showit == "[GALLERY_ITEMS]") { showGalleryItemsSection(); }
}
?>
<?php   doAccessoryStore(); ?>

</div>
</div>
<div class="pageContent" id="backtopricelist" <?php if(!empty($_REQUEST['package_id'])) { print "style=\"display: block;\""; }  else { print "style=\"display: none;\""; } ?>><a href="javascript:showPriceList();"><?php print icon_back;?> <?php print showText("back_to_price_list");?></a></div>
<div id="addToPackage">
<?php if(!empty($_REQUEST['package_id'])) { 
	$file_included = true;
	include "pc_products_to_packages.php";
}
?>
</div>
<?php
print "<div class=\"pageContent\">";
print showText("vi_crop");
print "</div>";
 ?>
<?php } ?>