<?php	
define("_default_search_text_", "Search tags"); 
$thumbs_per_page = 20;

function showHeldPhotos() { 
	global $setup;
	if(is_array($_SESSION['trayPhotos'])) { 
		foreach($_SESSION['trayPhotos'] AS $pic_id) { 
			if($pic_id > 0) { 
				$pic = doSQL("pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*", "WHERE pics.pic_id='".$pic_id."' ");
				if(!empty($pic['pic_id'])) { 
					if(!empty($pic['pic_folder'])) { 
						$pic_folder = $pic['pic_folder'];
					} else { 
						$pic_folder = $pic['gal_folder'];
					}
					$size = @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$pic_folder."/".$pic['pic_th'].""); 
					?>
					<div class="heldMini">
					<div style="display: block;"><img src="<?php print "../".$setup['gallery_folder']."/".$pic_folder."/".$pic['pic_th'];?>" class="img"  title="<?php print $pic['pic_org'];?>" style="width: auto; height: 75px;"></div>
					<div class="heldMiniRemove"><a href="javascript:unSelectPhoto('<?php print $pic['pic_id'];?>');" title="Remove from tray" class="tip"><?php print icon_close;?></a></div>
					</div>
				<?php
				}
			}
		}
	}
}

function getSearchString() {
	if((!empty($_REQUEST['keyWord']))AND($_REQUEST['keyWord'] !== ""._default_search_text_."")==true)  { 

		$ck_file = explode(":",$_REQUEST['keyWord']);
		if(trim($ck_file[0]) == "file") { 
			$and_where .= "AND pic_org LIKE '%".trim($ck_file[1])."%' ";
		} else { 
			$keys = explode(" ",$_REQUEST['keyWord']);
			foreach($keys AS $key) { 
				$key = trim($key);
				if($key !== " ") { 
					$and_where .= "AND pic_keywords LIKE '%".$key."%' ";
				}
			}
		}
		// $and_where .= "AND pic_keywords LIKE '%".$_REQUEST['keyWord'].",%' ";
	}
	if($_REQUEST['keyWord']=="untagged") { 
		$and_where = "AND pic_keywords='' ";
	}

	if(!empty($_REQUEST['pic_camera_model'])) { 
		$and_where .= "AND pic_camera_model LIKE '%".$_REQUEST['pic_camera_model']."%' ";
	}
	if(!empty($_REQUEST['pic_gal'])) { 
		$and_where .= "AND pic_gal='".$_REQUEST['pic_gal']."' ";
	}
	if(!empty($_REQUEST['pic_upload_session'])) { 
		$and_where .= "AND pic_upload_session='".$_REQUEST['pic_upload_session']."' ";
	}

	if(!empty($_REQUEST['orientation'])) { 
		if($_REQUEST['orientation'] == "portrait") { 
			$and_where .= "AND pic_height>pic_width";
		}
		if($_REQUEST['orientation'] == "landscape") { 
			$and_where .= "AND pic_width>pic_height";
		}
		if($_REQUEST['orientation'] == "square") { 
			$and_where .= "AND (pic_height=pic_width AND pic_height>'0')";
		}

	}

	return $and_where;
}

function getSearchOrder() { 
	global $photo_setup;
	if(!empty($_REQUEST['orderBy'])) { 
		$search['orderby'] = "".$_REQUEST['orderBy']."";
	} else { 
		$search['orderby'] = "pic_order";
	}

	if(!empty($_REQUEST['acdc'])) { 
		$search['acdc'] = "".$_REQUEST['acdc']."";
	} else { 
		$search['acdc'] = "ASC";
	}
	return $search;
}


function fileInfo($pic_file) {
	global $tr;
	$pic_filesize= @FileSize("$pic_file"); 
	$sizeL= @GetImageSize("$pic_file"); 
		if(!empty($pic_filesize)) {
			if($pic_filesize > 1024000) {
				$bytes  = $pic_filesize / 1024000;
				$bytes = round($bytes,2). "MB";
			} else {
				$bytes  = $pic_filesize / 1024;
				$bytes = round($bytes,0). "KB";
			}
			$html .=  "$bytes";
			$html .=  " -   $sizeL[0]  X $sizeL[1] px";
		}
	return $html;
}


function jsPhotoVariables() { 
	if((!empty($_REQUEST['keyWord']))AND($_REQUEST['keyWord'] !== ""._default_search_text_."")==true)  { 
		$add_string = "keyWord=".htmlspecialchars(stripslashes($_REQUEST['keyWord']));
	}
	if(!empty($_REQUEST['pic_gal'])) {
		$add_string .= "|pic_gal=".$_REQUEST['pic_gal'];
	}
	if(!empty($_REQUEST['orderBy'])) {
		$add_string .= "|orderBy=".$_REQUEST['orderBy'];
	}
	if(!empty($_REQUEST['acdc'])) {
		$add_string .= "|acdc=".$_REQUEST['acdc'];
	}
	if(!empty($_REQUEST['pic_camera_model'])) {
		$add_string .= "|pic_camera_model=".$_REQUEST['pic_camera_model'];
	}
	if(!empty($_REQUEST['pic_upload_session'])) {
		$add_string .= "|pic_upload_session=".$_REQUEST['pic_upload_session'];
	}

	if(!empty($_REQUEST['pic_upload_session'])) {
		$add_string .= "|pic_upload_session=".$_REQUEST['pic_upload_session'];
	}
	if(!empty($_REQUEST['photo_blog'])) {
		$add_string .= "|photo_blog=".$_REQUEST['photo_blog'];
	}
	if(!empty($_REQUEST['untagged'])) { 
		$add_string .= "|pic_keywords=untagged ";
	}
	if(!empty($_REQUEST['view'])) { 
		$add_string .= "|view=".$_REQUEST['view']."";
	}
	if(!empty($_REQUEST['orientation'])) { 
		$add_string .= "|orientation=".$_REQUEST['orientation']."";
	}

	return $add_string;
}

function inlineDataField($type,$size,$rows,$table,$field,$table_id_name,$table_id,$current_value) {
	// $type = text , textarea
	// $size = text size of field
	// $rows = textarea rows
	// $table = database table name
	// $field = name of the field being updated
	// $table_id_name = name of the ID in the table
	// $table_id = the ID numbder of the row
	// $current_value = the current value of the field
	?>

	<?php if($type == "text") { ?>
	<div style="float: left; position: relative;">

		<div>
	<form method="post" name="editphotoinfo-<?php print $table_id."-".$field;?>" id="editphotoinfo-<?php print $table_id."-".$field;?>" action="javascript:saveInlineData('<?php print $field;?>-<?php print $table_id;?>','<?php print $table;?>','<?php print $field;?>','<?php print $table_id_name;?>','<?php print $table_id;?>','<?php print $field;?>-<?php print $table_id;?>-org','<?php print $field;?>-<?php print $table_id;?>-saved');"> 

		<input type="hidden" name="<?php print $field;?>[<?php print $table_id;?>]-org" value="<?php print htmlspecialchars(stripslashes($current_value));?>" id="<?php print $field;?>-<?php print $table_id;?>-org">

		<input type="text" <?php if($size > 2) { ?>style="width: 98%;"<?php } ?>  name="<?php print $field;?>-[<?php print $table_id;?>]" value="<?php print htmlspecialchars(stripslashes($current_value));?>" id="<?php print $field;?>-<?php print $table_id;?>" size="<?php print $size;?>" onfocus="stopArrowNav();"  onblur="saveInlineDataTab('<?php print $field;?>-<?php print $table_id;?>','<?php print $table;?>','<?php print $field;?>','<?php print $table_id_name;?>','<?php print $table_id;?>','<?php print $field;?>-<?php print $table_id;?>-org','<?php print $field;?>-<?php print $table_id;?>-saved');">
		</form>
	</div>
	<div id="<?php print $field;?>-<?php print $table_id;?>-saved" style="position: absolute; top: 0; left: 0; z-index: 5;"></div>
	</div>
	<div class="cssClear"></div>
	<?php } ?>

	<?php if($type == "textarea") { ?>
	<div style="float: left; position: relative;">
		<input type="hidden" name="<?php print $field;?>[<?php print $table_id;?>]-org" value="<?php print htmlspecialchars(stripslashes($current_value));?>" id="<?php print $field;?>-<?php print $table_id;?>-org">

		<textarea style="width: 98%;"  name="<?php print $field;?>-[<?php print $table_id;?>]" cols="<?php print $size;?>" rows="<?php print $rows;?>" id="<?php print $field;?>-<?php print $table_id;?>"  onfocus="stopArrowNav();"  onblur="saveInlineDataTab('<?php print $field;?>-<?php print $table_id;?>','<?php print $table;?>','<?php print $field;?>','<?php print $table_id_name;?>','<?php print $table_id;?>','<?php print $field;?>-<?php print $table_id;?>-org','<?php print $field;?>-<?php print $table_id;?>-saved');"><?php print htmlspecialchars(stripslashes($current_value));?></textarea>
	<div id="<?php print $field;?>-<?php print $table_id;?>-saved" style="position: absolute; top: 0; left: 0; z-index: 5;"></div>
	</form>
	</div>
	<div class="cssClear"></div>
	<?php } ?>
	<?php //How to use:  inlineDataField('text','40','1','ms_photos','pic_keywords','pic_id',$pic['pic_id'],$pic['pic_keywords']); ?>
<?php
}

function inlineDataFieldColors($type,$size,$rows,$table,$field,$table_id_name,$table_id,$current_value,$class,$onchange) {
	// $type = text , textarea
	// $size = text size of field
	// $rows = textarea rows
	// $table = database table name
	// $field = name of the field being updated
	// $table_id_name = name of the ID in the table
	// $table_id = the ID numbder of the row
	// $current_value = the current value of the field
	?>

	<?php if($type == "text") { ?>
	<div style="float: left; position: relative;">

		<div>
	<form method="post" name="editphotoinfo-<?php print $table_id."-".$field;?>" id="editphotoinfo-<?php print $table_id."-".$field;?>" action="javascript:saveInlineData('<?php print $field;?>-<?php print $table_id;?>','<?php print $table;?>','<?php print $field;?>','<?php print $table_id_name;?>','<?php print $table_id;?>','<?php print $field;?>-<?php print $table_id;?>-org','<?php print $field;?>-<?php print $table_id;?>-saved');"> 

		<input type="hidden" name="<?php print $field;?>[<?php print $table_id;?>]-org" value="<?php print htmlspecialchars(stripslashes($current_value));?>" id="<?php print $field;?>-<?php print $table_id;?>-org">

		<input type="text" <?php if($size > 2) { ?>style="width: 98%;"<?php } ?>  class="<?php print $class;?>" onchange="<?php print $onchange;?>" name="<?php print $field;?>-[<?php print $table_id;?>]" value="<?php print htmlspecialchars(stripslashes($current_value));?>" id="<?php print $field;?>-<?php print $table_id;?>" size="<?php print $size;?>" onfocus="stopArrowNav();"  onblur="saveInlineDataTab('<?php print $field;?>-<?php print $table_id;?>','<?php print $table;?>','<?php print $field;?>','<?php print $table_id_name;?>','<?php print $table_id;?>','<?php print $field;?>-<?php print $table_id;?>-org','<?php print $field;?>-<?php print $table_id;?>-saved');">
		</form>
	</div>
	<div id="<?php print $field;?>-<?php print $table_id;?>-saved" style="position: absolute; top: 0; left: 0; z-index: 5;"></div>
	</div>
	<div class="cssClear"></div>
	<?php } ?>


	<?php //How to use:  inlineDataField('text','40','1','ms_photos','pic_keywords','pic_id',$pic['pic_id'],$pic['pic_keywords']); ?>

<?php
}

function cleanUploadFileName($name) { 
	$image_use_name = strtolower($name);
	$image_use_name = str_replace(' ', '_', $image_use_name);
	$image_use_name = str_replace("&", "and", $image_use_name);
	$image_use_name = str_replace("#", "num", $image_use_name);
	$image_use_name = str_replace("?", "", $image_use_name);
	$image_use_name = str_replace('"', "", $image_use_name);
	$image_use_name = str_replace("'", "", $image_use_name);
	$image_use_name = str_replace("/", "", $image_use_name);
	$image_use_name = stripslashes(trim($image_use_name));
	return $image_use_name;
}

function galleryPreviewThumb($gallery) { 
	global $setup;
	if(!empty($gallery['gal_prev_image'])) {
		$thumb = "/".$setup['gallery_folder']."/".$gallery['gal_folder']."/".$gallery['gal_prev_image']."";
	} else {
		if(!empty($gallery['gal_preview'])) {

			$pic = doSQL("pics",  "*", " WHERE pic_id='".$gallery['gal_preview']."'");
			$pic_th = $pic['pic_th'];
		} else {

			$pic = doSQL("pics",  "*", "WHERE pic_gal='".$gallery['gal_id']."' ORDER BY pic_order ASC");
			$pic_th = $pic['pic_th'];
		}
		$th_folder = $gallery['gal_folder'];

			if((empty($pic_th)) AND (countIt("galleries", "WHERE gal_sub_gal='".$gallery['gal_id']."' ") > 0) ==true){
				$subg = doSQL("galleries", "gal_id, gal_sub_gal,gal_folder,gal_preview,gal_order", "WHERE gal_sub_gal='".$gallery['gal_id']."' ORDER BY gal_order, gal_title ASC  LIMIT 1");
				if(!empty($subg['gal_preview'])) {
					$pic = doSQL("pics",  "pic_id,pic_th,pic_gal", " WHERE pic_id='".$subg['gal_preview']."'  LIMIT 1");
					$pic_th = $pic['pic_th'];

				} else {
					$pic = doSQL("pics",  "pic_id,pic_th,pic_gal", "WHERE pic_gal='".$subg['gal_id']."' ORDER BY pic_id ASC  LIMIT 1");
					$pic_th = $pic['pic_th'];
				}
				$th_folder = $subg['gal_folder'];
			}

		if(!empty($pic_th)){
			$thumb =  "".$setup['gallery_folder']."/".$th_folder."/".$pic['pic_th']."";
		}
		if(!empty($thumb)) { 
	//		$size = @GetImageSize("".$setup['path']."/".$thumb.""); 
		}
	}
return $thumb;
}
?>
<?php
function displayGallery($pic,$gallery,$max_width,$max_height,$remove_access) { 
	global $setup, $photo_setup;
	if(!empty($pic['pic_th'])) { 
		$size = @GetImageSize("".$setup['path']."/".$pic['pic_th'].""); 
	}
	?>
	<div class="outter" id="subGal-<?php print $pic['gal_id'];?>" style="width: <?php print ($max_width + 20);?>px; height: <?php print ($max_height + 40);?>px;  " >
		<div class="in-a-style"   style="width: <?php print ($max_width + 20);?>px; height: <?php print ($max_height + 40);?>px;" >
			<div class="in-b">
				<div class="in-c" style="width: <?php print ($max_width + 20);?>px; height: <?php print ($max_height + 40);?>px;">
					<div class="content">
						<div><a href="manage.php?do=photocart&action=galleries&gal_id=<?php print $pic['gal_id'];?>"  title="<?php print $pic['gal_title'];?>">
						<?php if(empty($pic['pic_th'])) { ?>
							<div class="noPhoto" style="width: <?php print ($max_width - 20);?>px; height: <?php print ($max_height - 20);?>px; margin: auto;"><br><br>NO PHOTO</div>
						<?php } else { ?>
							<img src="<?php print "../".$pic['pic_th'];?>" class="thumbnail" style="cursor: pointer; bottom: 0;"  width="<?php print $size[0];?>" height="<?php print $size[1];?>">
						<?php } ?>
						</a></div>
						<div class="name"><a href="manage.php?do=photocart&action=galleries&gal_id=<?php print $pic['gal_id'];?>" title="<?php print $pic['gal_title'];?>"><?php print ai_folder_solo;?>  <?php print $pic['gal_title'];?></a> (<?php print  countIt("pics", "WHERE pic_gal='".$pic['gal_id']."' ");?>)</div>
						<?php if($remove_access == "1") { ?>
						<div><a href="manage.php?do=photocart&action=customers&customerAction=removeGallery&user_id=<?php print $pic['user_id'];?>" onClick="return confirm('Are you sure you want to do this?');" class="tip" title="Remove this gallery access">Remove access</a>
						</div>
						<?php } ?>
					</div>
				</div>
			</div>
		</div>
	</div>
<?php } ?>
