<div class="pageContent"><h1><a href="manage.php?do=slideshow">Slideshow</a> > Help</h1></div>

<?php require "slideshow-tabs.php"; ?>

<div id="roundedFormContain">
<div style="width: 49%;" class="left">
<p><h3>Slideshow Types</h3>
There are 2 types of slideshow types that can be displayed: <b>Flash  & HTML</b>.</p>

<p>The Flash Slideshow will only show on computers with flash installed (about 95%). It will not show on iPads.</p>

<p>The HTML Slideshow will show on all devices (computers & iPads) so it is more compatible and a new addition to the Photo Cart slideshow add-on.</p>

<p><h3>Pros & Cons</h3>
The Flash version will probably not be updated any more because I no longer program in flash. It can only handle about 50 or so photos in a slideshow before it bogs down. It does have the option for random transition effect where the HTML version does not.</p>

<p>The HTML version does not have any limits I have come across on the amount of photos and performance. But for music to play in all browsers you have to upload 2 different audio files: MP3 and OGG. (This is because the Firefox browser will not play MP3 files using the HTML audio tag).</p>



<p><h3>To add a slideshow to a gallery</h3>
When you add a slideshow to a gallery, a "Slideshow" button will show when viewing the gallery thumbnails (this is different from the slideshow when viewing full size photos with pricing). This slideshow will show in full screen.
</p>
<p>To add a slideshow to a gallery, when viewing the gallery in the admin, select the "More" tab and then Slideshow.</p>



<p><h3>To add a slideshow to a splash page</h3>
The Splash Page is a page that show when they enter the gallery before they view the thumbnails. </p>
<p>To add a slideshow to a gallery splash page, when viewing the gallery in the admin, select the "More" tab and then Splash Page.</p>

<p><h3>Selecting photos to use</h3>
When adding  a slideshow to a galllery, you have the option to either show all photos from the gallery, or you will select which photos to use. If you choose  the option where you select which photos to use, when viewing the thumbnails, check the select checkbox under the thumbails and a tray will open. Then you have the option to add the photos to the slideshow or splash page.
</p>


</div>











<div style="width: 49%;" class="right">
<p><h3>About Music</h3>
<p>You can upload music to play with the slideshow in both the flash & HTML versions. However, to get music to play in all browsers with the HTML version, you will need to have 2 types of files: .mp3 & .ogg.</p>

<p>Internet Explorer 9, Chrome, Safari & iPads with play the .mp3 file.<br>
Firefox will only play the .ogg file.
</p>

<p>If you want to upload a .ogg file so the music plays in Firefox, you will need to convert the MP3 file of the music into a OGG file and then upload both files.  At the time of this, there is a website with a free converter: http://media.io/  . You would upload the MP3 and it will convert it to a OGG file.
</p>
<p>Here is a search for other methods of converting MP3 to OGG: <br><a href="http://www.google.com/search?q=convert+mp3+to+ogg" target="_blank">http://www.google.com/search?q=convert+mp3+to+ogg</a></p>

<p>When uploading both file types, they must have the EXACT same file names (minus the extension). For example: this-is-my-jam.mp3 and this-is-my-jam.ogg.</p>

<p><h3>Uploading audio files</h3>
There is a form to upload audio files and you can also upload them with FTP. The form upload may fail because of timeouts and server restrictions. So if you are unsuccessful uploading audio file with the upload form, then you will need to upload via FTP first.</p>

<p><b>To upload with FTP</b><br>
Connect to your website with your FTP program. Navigate to slideshow_audio folder which is inside your Photo Cart folder. Upload your audio file there. If you are using the HTML slideshow and want to upload an OGG file, upload both.</p>

<p>After the audio file(s) have uploading, go to the Slideshow > Audio FIles section and click the Scan for new files link. This will add the file to the system.</p>


<p><b>To upload with the upload form</b><br>
Click the browse button to select the song you want to upload and click upload. If you are using the HTML slideshow and wanting to upload the OGG file to play in Firefox, upload it after you have uploaded the MP3 file.</p>

<p>If you are unsuccessful uploading with the upload form, you will need to upload via FTP.</p>
</div>
<div class="clear"></div>
</div>