<?php
if(!function_exists(photoCartIncluded)) { die("Direct file access denied"); }
function ResizeImage($imagex,$maxwidth,$maxheight,$name, $photo_setup, $setup) {
	$imagex = imagecreatefromjpeg("$imagex"); 
	$width = imagesx($imagex);
	$height = imagesy($imagex);
	if(($maxwidth && $width > $maxwidth) || ($maxheight && $height > $maxheight)){
		if($maxwidth && $width > $maxwidth){
			$widthratio = $maxwidth/$width;
			$RESIZEWIDTH=true;
		}
		if($maxheight && $height > $maxheight){
			$heightratio = $maxheight/$height;
			$RESIZEHEIGHT=true;
		}
		if($RESIZEWIDTH && $RESIZEHEIGHT){
			if($widthratio < $heightratio){
				$ratio = $widthratio;
			}else{
				$ratio = $heightratio;
			}
		}elseif($RESIZEWIDTH){
			$ratio = $widthratio;
		}elseif($RESIZEHEIGHT){
			$ratio = $heightratio;
		}
    	$newwidth = ceil($width * $ratio);
        $newheight = ceil($height * $ratio);
		if(function_exists("imagecopyresampled")){
      		$newim = imagecreatetruecolor($newwidth, $newheight);
      		imagecopyresampled($newim, $imagex, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
		}else{
			$newim = imagecreate($newwidth, $newheight);
      		imagecopyresized($newim, $imagex, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
		}
		ImageJpeg ($newim,$name . "$image_ext", 93);
		ImageDestroy ($newim);
	}else{
		ImageJpeg ($imagex,$name . "$image_ext", 93);
	}
	ImageDestroy ($imagex);
}


function ResizeImageWatermark($imagex,$maxwidth,$maxheight,$name, $photo_setup, $setup) {
	$imagex = imagecreatefromjpeg("$imagex"); 
	$width = imagesx($imagex);
	$height = imagesy($imagex);
	if(($maxwidth && $width > $maxwidth) || ($maxheight && $height > $maxheight)){
		if($maxwidth && $width > $maxwidth){
			$widthratio = $maxwidth/$width;
			$RESIZEWIDTH=true;
		}
		if($maxheight && $height > $maxheight){
			$heightratio = $maxheight/$height;
			$RESIZEHEIGHT=true;
		}
		if($RESIZEWIDTH && $RESIZEHEIGHT){
			if($widthratio < $heightratio){
				$ratio = $widthratio;
			}else{
				$ratio = $heightratio;
			}
		}elseif($RESIZEWIDTH){
			$ratio = $widthratio;
		}elseif($RESIZEHEIGHT){
			$ratio = $heightratio;
		}
    	$newwidth = $width * $ratio;
        $newheight = $height * $ratio;
		if(function_exists("imagecopyresampled")){
      		$newim = imagecreatetruecolor($newwidth, $newheight);
      		imagecopyresampled($newim, $imagex, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
		}else{
			$newim = imagecreate($newwidth, $newheight);
      		imagecopyresized($newim, $imagex, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);		
		}



		$trans = ("".$setup['path']."/watermark.jpg");
		$size = getimagesize($trans); 
		$logomidw = $size[0] / 2;
		$logomidh = $size[1] / 2;
		$left = ($newwidth / 2) - $logomidw;
		$top = ($newheight / 2) - $logomidh;

		$m_w = $newwidth;
		$m_h = $newheight - 25;
	    $t_h = $newheight - 2;
		$t_w = $newwidth / 2 -110;
		 $logo = imagecreatefromjpeg($trans);

//		 $white = imagecolorallocate($newim, 255, 255, 255);
//		  $grey = imagecolorallocate($newim, 150, 150, 150);

		$opc = $photo_setup['watermark_trans'];
		if($newwidth > 120 AND $newheight > 120) {
		  imagecopymerge ($newim, $logo, $left, $top, 0, 0, $size[0], $size[1], $opc);
		}

		ImageJpeg ($newim,$name . "$image_ext", 93);
		ImageDestroy ($newim);

	
	}else{
		$opc = $photo_setup['watermark_trans'];

		$trans = ("".$setup['path']."/watermark.jpg");
		$size = getimagesize($trans); 
		$logomidw = $size[0] / 2;
		$logomidh = $size[1] / 2;
		$left = ($width / 2) - $logomidw;
		$top = ($height / 2) - $logomidh;

		$m_w = $width;
		$m_h = $height - 25;
	    $t_h = $height - 2;
		$t_w = $width / 2 -110;
		$logo = imagecreatefromjpeg($trans);

	  if($width > 120 AND $height > 120) {

		  imagecopymerge($imagex, $logo, $left, $top, 0, 0, $size[0], $size[1], $opc);
	  }
		ImageJpeg ($imagex,$name . "$image_ext", 93);
	}
	ImageDestroy ($imagex);
}