<?php 
session_start();
include_once("config.php");
include_once("functions.php");

?>

<script type="text/javascript">

function SubmitForm()
{
	document.myform.submit();
}

</script>

<?php 
	if($sandbox)
	{
		echo '<div style="margin-left:100px;">';
		echo "<b>WARNING:</b> Sandbox Mode is enabled. Payments will not be processed.<br>";
		echo '</div>';
	}
	
	if($debugging)
	{
		echo '<div style="margin-left:100px;">';
		echo "<b>WARNING:</b> Debug Output is enabled.<br><br>";
		echo '</div>';
	}
	
	if (file_exists($cert_url))
	{	  
	  $fp = fopen($cert_url, "r");
	  $file_contents = fread($fp, filesize($cert_url));
	  fclose($fp);
	} 
	else 	
	{
		$displayMsg = "Error: The api certificate does not exist<br>The location that was checked was: " . $cert_url . "<br>";
	}
	
	$soapData = SOAP_SetExpressCheckoutRequest($_POST);
	$response = SendSoapToPayPal($soapData);

	$arr_vals = xml2php($response);
	

	$PaypalResponse = array();
	
	foreach($arr_vals as $name => $value)
	{
		if(is_array($value))
		{			
			foreach($value as $name2 => $value2) 
			{
				if ($name2 == "tag") 
					$tag_value = $value2;
				if ($name2 == "value")
					$PaypalResponse[$tag_value] = $value2;
			}
		}
	}
	

	if($debugging) {
		echo "<pre>";
		echo "<b>Posted Data:</b><br><br>";
		print_r($_POST);
		echo "</pre>";

		echo "<b>Soap Request:</b><br>";
		print_xml($soapData);
		echo "<pre>";
		echo "<b>Paypal Response:</b><br><br>";
		print_r($PaypalResponse);
		echo "</pre>";				
	}

	$_SESSION["OrderTotal"] = $_POST["paymentAmount"];
	$_SESSION["OrderNumber"] = $_POST["InvoiceID"];
	
?>

<form action='<?php  echo $PaypalSite; ?>' method='GET' name='myform'>
	<INPUT TYPE="hidden" NAME="cmd" VALUE="_express-checkout">
	<INPUT TYPE="hidden" NAME="token" VALUE="<?php  echo $PaypalResponse["TOKEN"]; ?>">
	<INPUT TYPE="hidden" NAME="login_email" VALUE="">
</form>

<?php 

	if($debugging)
		echo "DEBUG MODE ENABLED, AUTOPOST DISABLED: <a href='#' onclick='SubmitForm();'>Click here to POST this page.</a>";
	else
		print "<b>If you are not automatically redirected, <a href='#' onclick='SubmitForm();'>click here to continue.</a>.</b>";
		echo "<script>SubmitForm();</script>";
?>