<?php 
/************************************************************************
			Written by Hunter Sinclair - All Rights Reserved.
			Copyright 2005 - Zenatdesign.com.
			Please contact hunter@ggi.net for licensing or purchase
			Do not remove this from file.
			Version 1.1
************************************************************************/
require_once("config.php");
function getRealIpAddr(){  
      if (!empty($_SERVER['HTTP_CLIENT_IP']))  
      //check ip from share internet  
      {  
        $ip=$_SERVER['HTTP_CLIENT_IP'];  
      }  
      elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))  
      //to check ip is pass from proxy  
      {  
        $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];  
      }  
      else  
      {  
        $ip=$_SERVER['REMOTE_ADDR'];  
      }  
      return $ip;  
}

function format_money($ammt){
	return "$" . number_format($ammt, 2, '.', ',');
}

function xml2php($data) {
   $xml_parser = xml_parser_create();
   xml_parse_into_struct($xml_parser, $data, $arr_vals);
   xml_parser_free($xml_parser);

   return $arr_vals;
}

function renderXML($bulk)
{/*
	$xml_parser = xml_parser_create();
   	xml_parse_into_struct($xml_parser, $bulk, $arr_vals);
   	xml_parser_free($xml_parser);*/
	$bulk = str_replace("\n", "", $bulk);
	$arrvals = xml2php($bulk);
	print_r($arr_vals);
}
function SOAP_DoDirectPaymentRequest($POST)
{
	global $api_username, $api_password, $storename;
	$IP = getRealIpAddr();
$IP = str_replace("\, 1","",$IP);
$IP = str_replace(",","",$IP);
$IP = str_replace(" ","",$IP);
$IP = str_replace(",","",$IP);

$soapXML = <<< QUOTE
<?php xml version="1.0" encoding="utf-8"?>
	<SOAP-ENV:Envelope
	 	xmlnssi="http://www.w3.org/1999/XMLSchema-instance"
	 	xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
	 	xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
	 	xmlnssd="http://www.w3.org/1999/XMLSchema"
	 	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
			<SOAP-ENV:Header>
				<RequesterCredentials xmlns="urn:ebay:api:PayPalAPI" xsi:type="ebl:CustomSecurityHeaderType" SOAP-ENV:mustUnderstand="1">
					<Credentials xmlns="urn:ebay:apis:eBLBaseComponents" xsi:type="ebl:UserIdPasswordType">
						<Username xsi:type="xs:string">$api_username</Username>
						<Password xsi:type="xs:string">$api_password</Password>
						<Signature xsi:type="xs:string"></Signature>
						<Subject/>
					</Credentials>
				</RequesterCredentials>
			</SOAP-ENV:Header>
			<SOAP-ENV:Body>
				<DoDirectPaymentReq xmlns="urn:ebay:api:PayPalAPI">
					<DoDirectPaymentRequest xsi:type="nsoDirectPaymentRequestType">
						<Version xmlns="urn:ebay:apis:eBLBaseComponents" xsi:type="xsd:string">63.0</Version>
						<DoDirectPaymentRequestDetails xmlns="urn:ebay:apis:eBLBaseComponents">
							<PaymentAction>Sale</PaymentAction>
							<PaymentDetails>
								<OrderTotal currencyID="USD">$POST[paymentAmount]</OrderTotal>
								<ButtonSource>Grissett_SP</ButtonSource>
								<OrderDescription>$storename Order $POST[InvoiceID]</OrderDescription>
							</PaymentDetails>
							<CreditCard>
								<CreditCardType>$POST[creditCardType]</CreditCardType>
								<CreditCardNumber>$POST[creditCardNumber]</CreditCardNumber>
								<ExpMonth>$POST[expMonth]</ExpMonth>
								<ExpYear>$POST[expYear]</ExpYear>
								<CardOwner>
										<PayerName>
											<FirstName>$POST[buyerFirstName]</FirstName>
											<LastName>$POST[buyerLastName]</LastName>
										</PayerName>
										<Address>
											<Street1>$POST[buyerAddress1]</Street1>
											<Street2>$POST[buyerAddress2]</Street2>
											<CityName>$POST[buyerCity]</CityName>
											<StateOrProvince>$POST[buyerState]</StateOrProvince>
											<PostalCode>$POST[buyerZipCode]</PostalCode>
											<Country>$POST[buyerCountry]</Country>
										</Address>
									</CardOwner>
									<CVV2>$POST[CVV2]</CVV2>
								</CreditCard>
								<IPAddress>$IP</IPAddress>
							</DoDirectPaymentRequestDetails>
						</DoDirectPaymentRequest>
					</DoDirectPaymentReq>
				</SOAP-ENV:Body>
	</SOAP-ENV:Envelope>

QUOTE;

	return $soapXML;
}
?>

<?php 
function DoRedirect($response)
{
	global $doRedirect, $redirectPage, $debugging;

	if(!$response)
		die("Paypal response was NULL.");
		
	if ($doRedirect)
	{
		$RedirectParameters = $redirectPage;
		$RedirectParameters = $RedirectParameters . "?ACK=" . $response["ACK"];
		$RedirectParameters = $RedirectParameters . "&COR_ID=" . urlencode($response["CORRELATIONID"]);
		$RedirectParameters = $RedirectParameters . "&AMOUNT=" . urlencode($response["AMOUNT"]);
		$RedirectParameters = $RedirectParameters . "&ERR_CODE=" . $response["ERRORCODE"];
		$RedirectParameters = $RedirectParameters . "&ERR_SHORT=" . urlencode($response["SHORTMESSAGE"]);
		$RedirectParameters = $RedirectParameters . "&ERR_LONG=" . urlencode($response["LONGMESSAGE"]);
		$RedirectParameters = $RedirectParameters . "&WARNING=" . urlencode($response["WARNING"]);
		$RedirectParameters = $RedirectParameters . "&AVS_CODE=" . $response["AVSCODE"];
		$RedirectParameters = $RedirectParameters . "&CVV2_CODE=" . $response["CVV2CODE"];
		$RedirectParameters = $RedirectParameters . "&TRANS_ID=" . urlencode($response["TRANSACTIONID"]);
		$RedirectParameters = $RedirectParameters . "&SEVERITY=" . urlencode($response["SEVERITYCODE"]);
		$RedirectParameters = $RedirectParameters . "&CUSTOM=" . urlencode($response["CUSTOMINFORMATION"]);
		
		// do redirect
	}
	else
	{	
		if($redirectPage == "")
			die("Redirect Page can not be NULL. Please correct this in your config file.");	
		echo "<form action='$redirectPage' method='POST' name='myform'>";	

		$displayMsg = "";
		
		if ($response["ACK"] == "Success" || $response["ACK"] == "SuccessWithWarnings")
		{
			$displayMsg = $displayMsg . "Order Successful<br>";
			$errorOut = false;
		}
		else
		{
			$displayMsg = $displayMsg . "ERROR - Order Failed<br>";
			$errorOut = true;
		}
	
		echo "<input type='hidden' name='ACK' value='$response[ACK]'>";
		
		if (isset($response["SHORTMESSAGE"]))
		{
			$displayMsg = $displayMsg . "Error Code: " . $response["ERRORCODE"] . "<br>Error Message: " . addslashes($response["SHORTMESSAGE"]) . "<br>Error Description: " . addslashes($response["LONGMESSAGE"]) . "<br>";		
			echo "<input type='hidden' name='ECODE' value='" . $response["ERRORCODE"] . "'>";
			echo "<input type='hidden' name='EMSGLONG' value='" . addslashes($response["LONGMESSAGE"]) . "'>";
			echo "<input type='hidden' name='EMSGSHORT' value='" . addslashes($response["SHORTMESSAGE"]) . "'>";
			$errorOut = true;
		}
		if (isset($response["Warning"]))
		{
			$displayMsg = $displayMsg . "Warning: " . $response["WARNING"] . "<br>";
			echo "<input type='hidden' name='WARNING' value='" . $response["WARNING"] . "'>";
		}
	
		if ($errorOut)
		{		
			switch($response["AVSCODE"])
			{
				case "A":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Address Matched - No Zip Match'>";
					$displayMsg = $displayMsg . "Address Matched - No Zip Match<br>";
					break;
				case "B":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='International Address Matched - No Zip Match'>";
					$displayMsg = $displayMsg . "International Address Matched - No Zip Match<br>";
					break;
				case "C":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='International Address Matched - No Zip Match'>";
					$displayMsg = $displayMsg . "International Address and Zip did not match<br>";
					break;
				case "D":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='International Address Matched - No Zip Match'>";
					$displayMsg = $displayMsg . "International Address and Zip did match<br>";
					break;
				case "E":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Not allowed for MOTO (Internet/Phone) transactions'>";
					$displayMsg = $displayMsg . "Not allowed for MOTO (Internet/Phone) transactions<br>";
					break;
				case "F":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='UK-specific “X” Address and Postal Code Matched'>";
					$displayMsg = $displayMsg . "UK-specific “X” Address and Postal Code Matched<br>";
					break;
				case "G":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Global Address Match Unavailable'>";
					$displayMsg = $displayMsg . "Global Address Match Unavailable<br>";
					break;
				case "I":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='International Address Match Unavailable'>";
					$displayMsg = $displayMsg . "International Address Match Unavailable<br>";
					break;
				case "N":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='No Address or Zip Match'>";
					$displayMsg = $displayMsg . "No Address or Zip Match<br>";
					break;
				case "P":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='International Postal Code Matched. Address did not match.'>";
					$displayMsg = $displayMsg . "International Postal Code Matched. Address did not match.<br>";
					break;
				case "R":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Retry Please'>";
					$displayMsg = $displayMsg . "Retry Please<br>";
					break;
				case "S":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Address match service not supported'>";
					$displayMsg = $displayMsg . "Address match service not supported<br>";
					break;
				case "U":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Address Match Unavailable'>";
					$displayMsg = $displayMsg . "Address Match Unavailable<br>";
					break;
				case "W":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Whole ZIP code matched. Address did not match.'>";
					$displayMsg = $displayMsg . "Whole ZIP code matched. Address did not match.<br>";
					break;
				case "X":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Exact match Address and nine-digit ZIP code'>";
					$displayMsg = $displayMsg . "Exact match Address and nine-digit ZIP code<br>";
					break;
				case "Y":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Matched Address and five-digit ZIP'>";
					$displayMsg = $displayMsg . "Matched Address and five-digit ZIP<br>";
					break;
				case "Z":
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Five-digit ZIP code matched. Address did not match.'>";
					$displayMsg = $displayMsg . "Five-digit ZIP code matched. Address did not match.<br>";
					break;
				case "":
					break;
				default:
					echo "<input type='hidden' name='AVSCode' value='" . $response["AVSCode"] . "'>";
					echo "<input type='hidden' name='AVSMsg' value='Error trying to match address or postal code.'>";
					$displayMsg = $displayMsg . "Error trying to match address or postal code.<br>";
					break;
			}
	
			if (!isset($response["CVV2Code"]))
				$cvvresponse = $response["CVV2Code"];
			
			switch($cvvresponse)
			{
				case "M":
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='Matched CVV2 Security Code'>";
					$displayMsg = $displayMsg . "Matched CVV2 Security Code<br>";
					break;
				case "N":
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='No match for CVV2 Security Code'>";
					$displayMsg = $displayMsg . "No match for CVV2 Security Code<br>";
					break;
				case "P":
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='CVV2 Security Code was not processed'>";
					$displayMsg = $displayMsg . "CVV2 Security Code was not processed<br>";
					break;
				case "S":
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='Checking CVV2 Security Code is not Supported for this card.'>";
					$displayMsg = $displayMsg . "Checking CVV2 Security Code is not Supported for this card.<br>";
					break;
				case "U":
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='CVV2 Security Code verification was Unavailable'>";
					$displayMsg = $displayMsg . "CVV2 Security Code verification was Unavailable<br>";
					break;
				case "X":
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='No response on CVV2 Security Code verification.'>";
					$displayMsg = $displayMsg . "No response on CVV2 Security Code verification.<br>";
					break;
				case "":
					break;
				default: 
					echo "<input type='hidden' name='CVV2Response' value='" . $response["CVV2Code"] . "'>";
					echo "<input type='hidden' name='CVV2Msg' value='Error trying to verify CVV2 Security Code.'>";
					$displayMsg = $displayMsg . "Error trying to verify CVV2 Security Code.<br>";
					break;
			}
		}
		
		echo "</form>";
		
		if($debugging)
			echo "DEBUG MODE ENABLED, AUTOPOST DISABLED: <a href='#' onclick='SubmitForm();'>Click here to POST this page.</a>";
		else
			echo "<script>SubmitForm();</script>";
	}
}

function SendSoapToPayPal($soapData) {

	global $cert_url, $PaypalAPIURL, $debugging;
	
	if($debugging)
		echo "API URL: $PaypalAPIURL<br><a href='$cert_url' target='_blank'>Certificate</a><br>";
		
	$soapData = trim($soapData);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $PaypalAPIURL);
	curl_setopt($ch, CURLOPT_SSLCERT, $cert_url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $soapData);
	$temp = curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$returnedData = curl_exec ($ch);
    $error = curl_error( $ch );

    if( !empty( $error )) {
      $html = "<br><b>CURL ERROR:</b> " .$error."<br>";
	  echo $html;
 	  curl_close ($ch);
      return $returnedData;
    }
	curl_close ($ch);
	return $returnedData;
}

function print_xml($data){
	$data = str_replace("<", "&lt;", $data);
	$data = str_replace(">", "&gt;", $data);
	echo "<pre>$data</pre>";

}

function SOAP_SetExpressCheckoutRequest($POST){
	global $api_username, $api_password, $cancel_payment_url, $root_ssl_url, $storename;
	$return_url = $root_ssl_url . "ec_process.php";
	$setExpressCheckoutRequest = <<< QUOTE
	<?php xml version="1.0" encoding="UTF-8"?>
	<SOAP-ENV:Envelope
		xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
		xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
		xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
		xmlns:xsd="http://www.w3.org/1999/XMLSchema"
		SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
		<SOAP-ENV:Header>
			<RequesterCredentials xmlns="urn:ebay:api:PayPalAPI" SOAP-ENV:mustUnderstand="1">
				<Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
					<Username>$api_username</Username>
					<Password>$api_password</Password>
					<Subject></Subject>
					<Signature></Signature>
				</Credentials>
			</RequesterCredentials>
		</SOAP-ENV:Header>
		<SOAP-ENV:Body>
			<SetExpressCheckoutReq xmlns="urn:ebay:api:PayPalAPI">
				<SetExpressCheckoutRequest>
					<Version xmlns="urn:ebay:apis:eBLBaseComponents">63.0</Version>
					<SetExpressCheckoutRequestDetails xmlns="urn:ebay:apis:eBLBaseComponents">
						<PaymentAction>Sale</PaymentAction>
						<OrderTotal currencyID="USD" xsl:type="cc:BasicAmountType">$POST[paymentAmount]</OrderTotal>						
						<OrderDescription>$storename - Order $POST[InvoiceID]</OrderDescription>
						<ButtonSource>Grissett_SP</ButtonSource>
						<ReturnURL>$return_url</ReturnURL>
						<CancelURL>$cancel_payment_url</CancelURL>
						<BuyerEmail>enter@email.com</BuyerEmail>
					</SetExpressCheckoutRequestDetails>
				</SetExpressCheckoutRequest>
			</SetExpressCheckoutReq>
		</SOAP-ENV:Body>
	</SOAP-ENV:Envelope>
QUOTE;

	return $setExpressCheckoutRequest;
}
?>
<?php 
function SOAP_GetExpressCheckoutDetailsRequest($token){
	global $api_username, $api_password;
	
	$getExpressCheckoutDetailsRequest = <<< QUOTE
	<?php xml version="1.0" encoding="UTF-8"?>
	<SOAP-ENV:Envelope
		xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
		xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
		xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
		xmlns:xsd="http://www.w3.org/1999/XMLSchema"
		SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
		<SOAP-ENV:Header>
			<RequesterCredentials xmlns="urn:ebay:api:PayPalAPI" SOAP-ENV:mustUnderstand="1">
				<Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
					<Username>$api_username</Username>
					<Password>$api_password</Password>
					<Subject></Subject>
				</Credentials>
			</RequesterCredentials>
		</SOAP-ENV:Header>
		<SOAP-ENV:Body>
			<GetExpressCheckoutDetailsReq xmlns="urn:ebay:api:PayPalAPI">
				<GetExpressCheckoutDetailsRequest>
					<Version xmlns="urn:ebay:apis:eBLBaseComponents">63.0</Version>
					<Token>$token</Token>
				</GetExpressCheckoutDetailsRequest>
			</GetExpressCheckoutDetailsReq>
		</SOAP-ENV:Body>
	</SOAP-ENV:Envelope>
QUOTE;

	return $getExpressCheckoutDetailsRequest;
}
?>
<?php 
function SOAP_DoExpressCheckoutPaymentRequest($token, $payerID){

	global $api_username, $api_password, $storename;
	
	$doExpressCheckoutPaymentRequest = <<< QUOTE
<?php xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope
	xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
	xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
	xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
	xmlns:xsd="http://www.w3.org/1999/XMLSchema"
	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
	
	<SOAP-ENV:Header>
		<RequesterCredentials xmlns="urn:ebay:api:PayPalAPI"
			SOAP-ENV:mustUnderstand="1">
			<Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
				<Username>$api_username</Username>
				<Password>$api_password</Password>
				<Subject></Subject>
				<Signature></Signature>
			</Credentials>
		</RequesterCredentials>
	</SOAP-ENV:Header>
	
	<SOAP-ENV:Body>
		<DoExpressCheckoutPaymentReq xmlns="urn:ebay:api:PayPalAPI">
			<DoExpressCheckoutPaymentRequest>
				<Version xmlns="urn:ebay:apis:eBLBaseComponents">63.0</Version>
				<DoExpressCheckoutPaymentRequestDetails xmlns="urn:ebay:apis:eBLBaseComponents">
					<Token>$token</Token>
					<PaymentAction>Sale</PaymentAction>
					<PayerID>$payerID</PayerID>
					<PaymentDetails>
						<OrderTotal currencyID="USD">$_SESSION[OrderTotal]</OrderTotal>			
						<ButtonSource>Grissett_SP</ButtonSource>
						<OrderDescription>$storename - Order $_SESSION[OrderNumber]</OrderDescription>
					</PaymentDetails>
				</DoExpressCheckoutPaymentRequestDetails>
			</DoExpressCheckoutPaymentRequest>
		</DoExpressCheckoutPaymentReq>
	</SOAP-ENV:Body>

</SOAP-ENV:Envelope>

QUOTE;

	return $doExpressCheckoutPaymentRequest;
}
?>