<?php 
// USA ePay PHP Library.
//      v1.4 
//
//      Copyright (c) 2002-2005 USA ePay
//      Written by Tim McEwen (tim@usaepay.com)
//
//  The following is an example of running a transaction using the php library.
//  Please see the README file for more information on usage.
//

include dirname(__FILE__)."/processor.usaepay.php";

$tran=new umTransaction;
 
$tran->key=trim($account_num);
$tran->ip=$REMOTE_ADDR;   // This allows fraud blocking on the customers ip address
$tran->testmode=0;
$tran->card="".trim($_POST['creditcard'])."";		// card number, no dashes, no spaces
$tran->exp=trim($_POST['month'])."".trim($_POST['year']);			// expiration date 4 digits no /
$tran->amount=trim($_POST['amount']);			// charge amount in dollars (no international support yet)
// $tran->amount="1.00";			// charge amount in dollars (no international support yet)
$tran->invoice=trim($_POST['order_number']);   		// invoice number.  must be unique.
$tran->cardholder="".trim($_POST['first_name'])." ".trim($_POST['last_name']).""; 	// name of card holder
$tran->street="".trim($_POST['address'])."";	// street address
$tran->zip="".trim($_POST['zip'])."";			// zip code
$tran->description="Order ".trim($_POST['order_number'])."";	// description of charge
$tran->cvv2=trim($_POST['cvv']);			// cvv2 code	

echo "<div align=center >Please Wait One Moment While We process your card.</div><br>\n";
flush();

if($tran->Process())
{
	echo "<b>Card approved</b><br>";
	echo "<b>Authcode:</b> " . $tran->authcode . "<br>";
	echo "<b>AVS Result:</b> " . $tran->avs_result . "<br>";
	echo "<b>Cvv2 Result:</b> " . $tran->cvv2_result . "<br>";

	$order_pay_amount =  $tran->amount;
	$order_pay_type =  $_POST['c_type']; // paypal, credit cart
	$order_pay_ref =  $tran->refnum; // transaction id
	$order_payment_type = ""; // visa, mc
	$order_id =  $tran->invoice;
	$order_name =  $tran->cardholder;
	$order_approve_code = $tran ->authcode;
	include "payment.update.php";
} else {
	$order= doSQL("pc_orders", "*, date_format(DATE_ADD(order_date, INTERVAL 0 HOUR), '%M %e, %Y ')  AS order_date", "WHERE order_id='".$tran->invoice."'" );

	echo "<b>Card Declined</b> (" . $tran->result . ")<br>";
	echo "<b>Reason:</b> " . $tran->error . "<br>";	
	header("location: index.php?do=photocart&action=payment&error=".urlencode($tran->error)."&order=".$order['order_key']." ");
	exit();
	if($tran->curlerror) echo "<b>Curl Error:</b> " . $tran->curlerror . "<br>";	
}		
?>