<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
include $setup['path']."/pc_inc/gallery_image_functions.php"; 
include $setup['path']."/pc_inc/view_image_functions.php"; 
include $setup['path']."/pc_inc/product_functions.php"; 
include $setup['path']."/pc_inc/packages_functions.php"; 
//require"pc_head.php"; 
$dbcon = dbConnect($setup);
securityCheck();
$site_setup = doSQL("pc_settings", "*", "");
$photo_setup = doSQL("photo_setup", "*", "");
	$get_style = $site_setup['template'];

if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
foreach($_REQUEST AS $id => $value) {
	$_REQUEST[$id] = addslashes(stripslashes(strip_tags($value)));
	$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
}
	$pic = doSQL("pics  LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*, date_format(DATE_ADD(pic_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS pic_date", " WHERE pic_id='".$_REQUEST['pic_id']."' ");
	$gallery = doSQL("galleries", "*, date_format(DATE_ADD(gal_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_date_show, date_format(DATE_ADD(gal_expire, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_expire_show", " WHERE gal_id='".$pic['pic_gal']."' ");

	$returnval = galleryTree($gallery,"pagetitle");
	$main_gallery = $returnval[2];

	if(empty($main_gallery)) { 
		$toplevelgallery = true;
		$main_gallery = $gallery['gal_id']; 
	} else {
		$main_gal = doSQL("galleries", "*, date_format(DATE_ADD(gal_expire, INTERVAL 2 HOUR), '%M %e, %Y ')  AS gal_expire_show", "WHERE gal_id='".$main_gallery."' ");
	}
$access_status = checkGalleryAccess();
if($access_status['gal_access_status'] == "expired") {
	die("no access");
}
if($access_status['gal_access_status'] == "access_form") {
	die("no access");
}

	unset($_SESSION['color']);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<script language="Javascript" src="js/jquery1.7.2.js"></script>
<script language="javascript" src="js/photocart.js" type="text/javascript"></script>
<script language="javascript" src="js/photocart7f.js" type="text/javascript"></script>
<?php
$sp = doSQL("size_price", "*", "WHERE sp_id='".$_REQUEST['sp_id']."' ");

$size= @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$gallery['gal_folder'].""."/".$pic['pic_pic'].""); 

$theImage = "image.php?image=".$pic['pic_id']."|d||".$bw."|".$colorize."|".$color_type."|".$add_crop."|".$width."|".$height."||".date('Ymdhis')."";

if(!empty($_REQUEST['rc'])) {
	$old_crop = doSQL("pc_crops", "*", "WHERE MD5(crop_id)='".$_REQUEST['rc']."' ");
	if(!empty($old_crop['crop_id'])) {
		@unlink( $setup['path']."/".$setup['gallery_folder']."/crops/".$old_crop['crop_url']);
	}
}

if($_REQUEST['rotate'] == 1) { 
	$dem = getCropDems($size[1],$size[0],$sp['sp_width'],$sp['sp_height'],$sp['sp_crop_min']);
} else { 
	$dem = getCropDems($size[0],$size[1],$sp['sp_width'],$sp['sp_height'],$sp['sp_crop_min']);
}
/*
print "<li>NEW width: ".$dem['crop_width'];
print "<li>org width: ".$dem['org_width'];
print "<li>org height: ".$dem['org_height'];
print "<li>width: ".$dem['crop_width']."";
print "<li>height: ".$dem['crop_height']."";
print "<li>min width: ".$dem['min_width']."";
print "<li>min_height: ".$dem['min_height']."";
print "<li>x1: $x1";
print "<li>y1: $y1";
*/
?>

<title>Cropping</title>
<script language="javascript" src="<?php if($full_url == true) { print $setup['url']."/"; } ?>js/photocart.js" type="text/javascript"></script>
<script language="javascript" src="<?php if($full_url == true) { print $setup['url']."/"; } ?>js/photocart7f.js" type="text/javascript"></script>
<script src="pc_inc/cp/scripts/prototype.js" type="text/javascript"></script>
<script src="pc_inc/cp/scripts/scriptaculous.js?load=effects,builder,dragdrop" type="text/javascript"></script>
<script src="pc_inc/cp/scripts/cropper.js" type="text/javascript"></script>
<script type="text/javascript" charset="utf-8">
Event.observe ( 
	window, 
	'load', 
	function() { 
		new Cropper.Img ( 
			'theImageCrop',
			{
				minWidth: <?php print $dem['min_width'];?>, 
				minHeight: <?php print $dem['min_height']?>,
				ratioDim: { x:<?php print $dem['crop_width'];?>, y: <?php print $dem['crop_height'];?>},
				onEndCrop: saveCoords,
				onloadCoords: { x1: <?php print $dem['x1'];?>, y1: <?php print $dem['y1'];?>, x2: <?php print $dem['x2'];?>, y2: <?php print $dem['y2']; ?> },
				displayOnInit: true
			}
		) 
	}
);
        
function saveCoords (coords, dimensions)
{
	$( 'x1' ).value = coords.x1;
	$( 'y1' ).value = coords.y1;
	$( 'width' ).value = dimensions.width;
	$( 'height' ).value = dimensions.height;
}
</script>
<link rel="stylesheet" href="<?php if($full_url == true) { print $setup['url']."/"; } ?><?php print "pc_style2.php?csst=".$get_style."&ipad=$ipad&mobile=$mobile&wbg=".$_REQUEST['wbg']."&pc_included=".$pc_included."";?>" type="text/css">
</head>
<body>
    <form action="pc_save_crop.php" method="post" name="cropForm" id="cropForm">
    <div class="pageContent"><h3><?php print $tr['_crop_title_'];?></h3></div>
	<div class="pageContent"><?php print $tr['_crop_description_'];?></div>

	<div class="pageContent" style="text-align: center; width: <?php print $size[0];?>px; margin: auto;">   
	<?php if($sp['crop_rotate'] == "1") { ?>
	<a href="pc_crop.php?sp_id=<?php print $sp['sp_id'];?>&pic_id=<?php print $pic['pic_id'];?>&wbg=1&rotate=<?php if($_REQUEST['rotate'] == "1") { print "0"; } else { print "1"; } ?>"  class="submitSmall"><?php print $tr['rotate_crop_area'];?></a>  
	<?php } ?>
	<a href="" onClick="document.cropForm.submit(); return false;"  class="submitSmall"><?php print $tr['_crop_apply_'];?></a>  
	<a href="" onClick="closeCropping(); return false;"  class="submitSmall"><?php print $tr['_crop_cancel_'];?></a> </div>

    <div style="margin: auto; text-align: center; width: <?php print $size[0];?>px; height: <?php print $size[1];?>px;">
	<center>
        <img src="<?php print $theImage;?>" id="theImageCrop" alt="" width="<?php print $size[0];?>" height="<?php print $size[1];?>" />
		</center>
    </div>
       
    <input type="hidden" name="x1" id="x1" value="">
    <input type="hidden" name="y1" id="y1" value="">
    <input type="hidden" name="width" id="width" value="">
    <input type="hidden" name="height" id="height" value="">
    <input type="hidden" name="pic_id" id="pic_id" value="<?php print $pic['pic_id'];?>">
    <input type="hidden" name="sp_id" id="sp_id" value="<?php print $sp['sp_id'];?>">
    <input type="hidden" name="wbg" id="wbg" value="1">
	<div class="pageContent" style="text-align: center; width: <?php print $size[0];?>px; margin: auto;">   
	<?php if($sp['crop_rotate'] == "1") { ?>
	<a href="pc_crop.php?sp_id=<?php print $sp['sp_id'];?>&pic_id=<?php print $pic['pic_id'];?>&wbg=1&rotate=<?php if($_REQUEST['rotate'] == "1") { print "0"; } else { print "1"; } ?>"  class="submitSmall"><?php print $tr['rotate_crop_area'];?></a>  
	<?php } ?>
	<a href="" onClick="document.cropForm.submit(); return false;"  class="submitSmall"><?php print $tr['_crop_apply_'];?></a>  
	<a href="" onClick="closeCropping(); return false;"  class="submitSmall"><?php print $tr['_crop_cancel_'];?></a> 
	</div>
    </form>
</body>
</html>