<?php
include "functions.core.php"; 
function sqlTimeDiff() { 
	global $site_setup;
	if($site_setup['time_diff'] < 0) {
		$sql_diff = $site_setup['time_diff'] + -($site_setup['time_diff']*2);
	}
	if($site_setup['time_diff'] > 0) {
		$sql_diff = $site_setup['time_diff'] - ($site_setup['time_diff']*2);
	}
	if($site_setup['time_diff'] == 0) {
		$sql_diff = 0;
	}
	return $sql_diff;
}


function photoCartIncluded() {
	return true;
}





function showError($message) {
	global $tr;
	print "<div class=\"errorMessage\">";
	print "<li>".$tr['error'].": $message";
	print "</div></div><div class=\"cssClear\"></div>";
	include "pc_footer.php";

	die();
}

function sessionCheck() {
	if(( $_SESSION['pc_client_login'] !== true) ||  ($_SESSION['pc_client_id'] == NULL )) {
	$_SESSION['page_return'] = $_SERVER['REQUEST_URI'];
	session_write_close();
	header("Location: index.php?do=login");
	}
}
function isLoggedIn() {
	if(( $_SESSION['pc_client_login'] == true) &&  ($_SESSION['pc_client_id'] !== NULL )) {
		return true;
	}
}
function showPrice($amount) {
	global $tr,$order,$vat;
	$format = $tr['price_format'];
	$tr['currency'] = str_replace("","",$tr['currency']);  
	$html =str_replace("[CURRENCY_SIGN]", "".$tr['currency']."",$format);
	$html =str_replace("[PRICE]", "".number_format($amount,$tr['price_decimals'])."",$html);
	if(($tr['price_trim']=="1")AND($_REQUEST['action']!="checkout")AND($_REQUEST['do']!="reports")AND(empty($order['order_id']))==true) {
		$html = str_replace(".00", "",$html);
	}
	return $html;
}

function imageName($pic) {
	return  substr($pic['pic_org'],0,-4);
}


function galleryTree($gallery,$class) {
	global $_REQUEST,$site_setup,$setting;
	$up_gal = $gallery['gal_sub_gal'];
	while(!empty($up_gal)) {
		$tgal = doSQL("galleries", "*", "WHERE gal_id='$up_gal' ");
		$html = "<a href=\"index.php?do=photocart&viewGallery=".$tgal['gal_id']."\" class=$class>".$tgal['gal_title']."</a> > ". $html."";
		$up_gal = $tgal['gal_sub_gal'];
		$main_gal = $tgal['gal_id'];
	}
	if(empty($main_gal)) {
		if((!empty($gallery['gal_splash']))OR(!empty($gallery['gal_splash_slideshow']))==true) {
			$html = "<a href=\"index.php?do=photocart&viewGallery=".$gallery['gal_id']."&splash=yes\" class=$class>".showText("vi_intro")."</a> > ". $html."";
		}
	} else {
		if((!empty($tgal['gal_splash']))OR(!empty($tgal['gal_splash_slideshow']))==true) {
			$html = "<a href=\"index.php?do=photocart&viewGallery=".$tgal['gal_id']."&splash=yes\" class=$class>".showText("vi_intro")."</a> > ". $html."";
		}
	}
	$returnval[1] = $html;
	$returnval[2] = $main_gal;
	return $returnval;
}

	function imageTree($pic, $print_links,$class,$link_home) {
	$gallery = doSQL("galleries", "*", " WHERE gal_id='".$pic['pic_gal']."' ");
	if(!empty($gallery['gal_sub_gal'])) {
		$returnval = adminGalleryTree($gallery,$class);	
		$main_gallery = $returnval[2];
	} else {
		$main_gallery = $gallery['gal_id'];
	}

	$mg = doSQL("galleries", "*, date_format(DATE_ADD(gal_date, INTERVAL ".$site_setup['time_diff']." HOUR), '".$site_setup['date_format']." ')  AS gal_date_show, date_format(DATE_ADD(gal_expire, INTERVAL ".$site_setup['time_diff']." HOUR), '".$site_setup['date_format']." ')  AS gal_expire_show", "WHERE gal_id='$main_gallery' ");
	?>
	<?php
	if(!empty($mg['gal_under'])) {

		$cat = doSQL("pc_categories", "*", "WHERE cat_id='".$mg['gal_under']."' ");
		print "<a href=\"manage.php?do=photocart&action=galleries\" class=$class>Home</a>";
		$mens = explode(",", "".$cat['cat_under_ids']."");
		foreach($mens AS $men) {
			$menu = doSQL("pc_categories", "*", "WHERE cat_id='$men' " );
			if(!empty($menu['cat_id'])) {
				print " > <a href=\"manage.php?do=photocart&action=galleries&category=".$menu['cat_id']."\" class=$class>".$menu['cat_name']."</a>";
			}
		}
		print " > <a href=\"manage.php?do=photocart&action=galleries&category=".$cat['cat_id']."\" class=$class>".$cat['cat_name']."</a> > ";
	}

	 print $returnval[1]; 
	 ?>

	<a href="manage.php?do=photocart&action=galleries&gal_id=<?php print "".$gallery['gal_id']."";?>"  class=<?php print $class;?>><?php print "".$gallery['gal_title']."";?></a>
	 > <span class=<?php print $class;?>><?php print $pic['pic_org'];?></span>

	</td></tr></table>
<?php
		return $main_gallery;
}
if(!function_exists('mb_convert_encoding')) {
	function mb_convert_encoding($a,$b,$c) {
		return $a;
	}
}
function sendEmail($to_email, $to_name, $from_email, $from_name, $subject, $message) {
	global $site_setup,$_POST,$setup,$dont_add_breaks,$override_send_all;
	$htmlMail = $site_setup['mail_html'];
	if($htmlMail  == "1") {
		$he = doSQL("pc_html_emails", "*", ""); 
	}
	if($site_setup['mail_type'] == "1") {

		$smtp_phpmailer_url = "".$site_setup['smtp_phpmailer_url']."";
		$smtp_host = "".$site_setup['smtp_host']."";
		$smtp_username = "".$site_setup['smtp_username']."";
		$smtp_password = "".$site_setup['smtp_password']."";
		$smtp_from = "$from_email";
		$smtp_from_name = "$from_name";
		$smtp_to = "$to_email";
		$message = stripslashes($message);
		$subject = stripslashes($subject);


		include_once("$smtp_phpmailer_url");

		$mail = new PHPMailer();

		$mail->IsSMTP();
		$mail->Host = "$smtp_host";
		$mail->SMTPAuth = true;
		$mail->Username = "$smtp_username";
		$mail->Password = "$smtp_password";

		$mail->From = "$smtp_from";
		$mail->FromName = "$smtp_from_name";
		$mail->AddAddress("$smtp_to"); 
		if($htmlMail == "1") { 
			$mail->IsHTML(true);
		} else {
			$mail->IsHTML(false);
		}
		$mail->Subject = "$subject";

		if($htmlMail  == "1") {

			$send_message = "<html><head><STYLE type=text/css><!-- body, td, div, .a {	BACKGROUND-POSITION: left top; FONT-WEIGHT: none; FONT-SIZE: ".$he['font_size']."; background:#".$he['bg_color']."; color: #".$he['font_color']."; FONT-FAMILY: ".$he['font_family']."; }  --></style></head><body bgcolor=#".$he['bg_color']." leftmargin=10 topmargin=10 marginwidth=10 marginheight=10>"."";
			$send_message .= $he['e_header'];
			$send_message .= nl2br($message);
			$send_message .= $he['e_footer'];
			$message = $send_message;
		}

		$mail->Body = "$message";
		$mail->Send();



	} else {
		if($site_setup['all_email_from'] == "1") {
			if($override_send_all !== true) { 
				$from_name = $site_setup['website_name'];
				$from_email = $site_setup['contact_email'];
			}
		}
		// STANDARD MAIL
		$to = "$to_email";
		$subject = "$subject";
		 $headers .= 'X-Sender: '.$from_email. "\n"; 
		$headers .= "X-Path: ".$from_email."\n";

		$headers  .= 'MIME-Version: 1.0' . "\n";
		$headers .= "From: ".mb_convert_encoding($from_name, 'UTF-8', 'HTML-ENTITIES')." <".$from_email.">\n";
		$headers .= "Reply-To: ".mb_convert_encoding($from_name, 'UTF-8', 'HTML-ENTITIES')." <".$from_email.">\n";
		$headers .= "Return-Path: <".$from_email.">" . "\n";
		if($htmlMail  == "1") {
		  $headers .= "Content-type: text/html; charset=iso-8859-1"."\n";
		} else {
			$headers .= "Content-type: text/plain; charset=iso-8859-1"."\n";
		}
		$message = stripslashes($message);
		$subject = stripslashes($subject);

//		$subject = utf_decode($subject);
				$from = "$from_email";

		// Added for swedish character support.
		$subject = mb_convert_encoding($subject, 'iso-8859-1', 'HTML-ENTITIES');
		$message = mb_convert_encoding($message, 'iso-8859-1', 'HTML-ENTITIES');

		if($htmlMail  == "1") {

			$send_message = "<html><head><STYLE type=text/css><!-- html, body, td, div{ FONT-SIZE: ".$he['font_size']."; background:#".$he['bg_color']."; color: #".$he['font_color']."; FONT-FAMILY: ".$he['font_family']."; }  --></style></head><body bgcolor=#".$he['bg_color']." leftmargin=10 topmargin=10 marginwidth=10 marginheight=10>"."";
			$send_message .= $he['e_header'];
			if($dont_add_breaks == true) {
				$send_message .= $message;
			} else {
				$send_message .= nl2br($message);
			}
			$send_message .= "<br><br>".$he['e_footer'];
			$message = $send_message;
		} else {
			$message = strip_tags("$message");
		}
		if($setup['demo_mode'] !== true) { 
			if($site_setup['mail_return_path'] == "1") {
				mail($to,$subject,$message,$headers,"-f"."$from_email");
			} else {
				mail($to,$subject,$message,$headers);
			}
		}
		// print "<pre>$headers</pre>";

	}



	if(($_POST['do'] != "setup")AND($_REQUEST['action']!="payment")==true) {
		$from_email = sql_safe("$from_email");
		$to_email = sql_safe("$to_email");
		$subject = sql_safe("$subject");
		

		insertSQL("pc_email_logs", "log_from='".addslashes(stripslashes($from_email))."', log_to='".addslashes(stripslashes($to_email))."', log_subject='".addslashes(stripslashes($subject))."', log_text='".addslashes(stripslashes(strip_tags($message)))."', log_date=NOW() ");
	}
}

function customerLoggedIn() {
	 if(( $_SESSION['pc_client_login'] == true) AND  ($_SESSION['pc_client_id'] !== NULL ) == true) { 
		 return true;
	 }
}

function publicRestrictedAccess($gal_check) {
	if(!empty($_SESSION['public_access_gals'])) {
		if(in_array($gal_check, $_SESSION['public_access_gals'])) {
			return true;
		}
	}
}


function checkPendingPackageCredit($order) {
	if($order['order_pending_credit'] > 0) {
		$credit_id= insertSQL("pc_customer_credits", "credit_amount='".($order['order_pending_credit'])."', credit_notes='".addslashes(stripslashes("Credit left over from purchase of package on order ".$order['order_id']))."', credit_date=NOW(), credit_customer='".$order['order_client']."'");
		updateSQL("pc_orders", "order_pending_credit='0' WHERE order_id='".$order['order_id']."' ");
	}
}

function checkRegPayment($order) {
	$items = whileSQL("pc_order_items", "*", "WHERE ci_order='".$order['order_id']."' AND ci_reg_id!='0' " );
	if(mysql_num_rows($items) > 0) {
		while($item = mysql_fetch_array($items)) {
			$reg = doSQL("pc_registries", "*", "WHERE reg_id='".$item['ci_reg_id']."' ");
			if(countIt("pc_customer_credits", "WHERE credit_reg_order='".$order['order_id']."' AND credit_reg='".$reg['reg_id']."' AND credit_customer='".$reg['reg_client']."' ") <=0) {
				$buyer = doSQL("pc_clients", "*", "WHERE client_id='".$order['order_client']."' ");
				$credit_id= insertSQL("pc_customer_credits", "credit_amount='".($item['ci_qty'] * $item['ci_price'])."', credit_notes='".addslashes(stripslashes($item['ci_reg_message']))."', credit_date=NOW(), credit_customer='".$reg['reg_client']."', credit_reg='".$reg['reg_id']."', credit_reg_order='".$order['order_id']."', credit_reg_buyer='".$buyer['client_id']."' ");
				$reg_amount = ($item['ci_qty'] * $item['ci_price']);
				sendRegPurchaseEmail($order,$reg,$buyer,$reg_amount,$item);
			}
		}
	}

	$items = whileSQL("pc_order_items", "*", "WHERE ci_order='".$order['order_id']."' AND ci_gift_cert!='0' " );
	if(mysql_num_rows($items) > 0) {
		while($item = mysql_fetch_array($items)) {
			$gc = doSQL("pc_gift_certs", "*", "WHERE gc_id='".$item['ci_gift_cert']."' ");
			if(!empty($gc['gc_id'])) {
				$gcs = doSQL("pc_gift_cert_settings", "*", "");
				$gc_expire  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") + $gcs['gcs_days'], date("Y")));

				updateSQL("pc_gift_certs", "gc_status='1', gc_date=NOW(), gc_expire='$gc_expire', gc_order_id='".$order['order_id']."' WHERE gc_id='".$gc['gc_id']."'");
				$reg_amount = ($item['ci_qty'] * $item['ci_price']);
				sendGiftCertEmail($order,$gc,$item,$gcs);
			}
		}
	}


}

function sendRegPurchaseEmail($order,$reg,$buyer,$reg_amount,$item) {
	global $setup, $site_setup,$tr;
	$client = doSQL("pc_clients", "*", "WHERE client_id='".$reg['reg_client']."' ");
	$em = doSQL("pc_emails", "*", "WHERE email_id='12' ");
	if(!empty($em['email_id'])) {
		if(empty($em['email_from_email'])) {
			$from_email = $site_setup['contact_email'];
		} else {
			$from_email = $em['email_from_email'];
		}

		if(empty($em['email_from_name'])) {
			$from_name = $site_setup['website_name'];
		} else {
			$from_name = $em['email_from_name'];
		}
		$subject = "".$em['email_subject']."";
		

		$to_email = $client['client_email'];
		$to_name = $client['client_name'];
		$message = $em['email_message'];

		$reg_amount = showPrice($reg_amount);
		$message = str_replace("[URL]",$setup['url'], "$message");
		$message = str_replace("[REGISTRY_NAME]",$reg['reg_name'], "$message");
		$message = str_replace("[WEBSITE_NAME]",$site_setup['website_name'], "$message");
		$message = str_replace("[NAME]",$client['client_name']." ".$client['client_last_name'], "$message");
		$message = str_replace("[REGISTRY_AMOUNT]",$reg_amount, "$message");
		$message = str_replace("[REGISTRY_MESSAGE]","".$item['ci_reg_message']."", "$message");
		$message = str_replace("[BUYER_NAME]",$buyer['client_name']." ".$buyer['client_last_name'], "$message");
		$message = str_replace("[ORDER_NUMBER]",$order_num, "$message");

		$subject = str_replace("[NAME]",$client['client_name'], "$subject");
		$subject = str_replace("[WEBSITE_NAME]",$site_setup['website_name'], "$subject");
		stripslashes($message);
		stripslashes($subject);
		sendEmail($to_email, $to_name, $from_email, $from_name, $subject, $message);
	}

}

function sendGiftCertEmail($order,$gc,$item,$gcs) {
	global $setup, $site_setup,$tr;
	$gc = doSQL("pc_gift_certs", "*, date_format(DATE_ADD(gc_expire, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gc_expire_show", "WHERE gc_id='".$gc['gc_id']."' ");

	$client = doSQL("pc_clients", "*", "WHERE client_id='".$reg['reg_client']."' ");
	$em = doSQL("pc_emails", "*", "WHERE email_id='13' ");
	if(!empty($em['email_id'])) {
		if(empty($em['email_from_email'])) {
			$from_email = $site_setup['contact_email'];
		} else {
			$from_email = $em['email_from_email'];
		}

		if(empty($em['email_from_name'])) {
			$from_name = $site_setup['website_name'];
		} else {
			$from_name = $em['email_from_name'];
		}
		$subject = "".$em['email_subject']."";
		

		$to_email = $gc['gc_to_email'];
		$to_name = $client['gc_to_name'];
		$message = $em['email_message'];

		$gc_amount = showPrice($gc['gc_amount']);
		$message = str_replace("[URL]",$setup['url'], "$message");
		$message = str_replace("[WEBSITE_NAME]",$site_setup['website_name'], "$message");
		$message = str_replace("[TO_NAME]",$gc['gc_to_name'], "$message");
		$message = str_replace("[TO_EMAIL]",$gc['gc_to_email'], "$message");
		$message = str_replace("[FROM_NAME]",$gc['gc_from_name'], "$message");
		$message = str_replace("[FROM_EMAIL]",$gc['gc_from_email'], "$message");
		$message = str_replace("[AMOUNT]",showPrice($gc['gc_amount']), "$message");
		$message = str_replace("[REDEEM_CODE]",$gc['gc_key'], "$message");
		$message = str_replace("[MESSAGE]",$gc['gc_message'], "$message");
		$message = str_replace("[EXPIRATION_DATE]",$gc['gc_expire_show'], "$message");
		$message = str_replace("[TERMS]",$gcs['gcs_terms'], "$message");


		$subject = str_replace("[NAME]",$client['client_name'], "$subject");
		$subject = str_replace("[WEBSITE_NAME]",$site_setup['website_name'], "$subject");

		$subject = str_replace("[TO_NAME]",$gc['gc_to_name'], "$subject");
		$subject = str_replace("[TO_EMAIL]",$gc['gc_to_email'], "$subject");
		$subject = str_replace("[FROM_NAME]",$gc['gc_from_name'], "$subject");
		$subject = str_replace("[FROM_EMAIL]",$gc['gc_from_email'], "$subject");
		$subject = str_replace("[AMOUNT]",$gc['gc_amount'], "$subject");
		$subject = str_replace("[REDEEM_CODE]",$gc['gc_key'], "$subject");
		$subject = str_replace("[MESSAGE]",$gc['gc_message'], "$subject");
		$subject = str_replace("[EXPIRATION_DATE]",$gc['gc_expire'], "$subject");

		stripslashes($message);
		stripslashes($subject);
		sendEmail($to_email, $to_name, $from_email, $from_name, $subject, $message);
	}

}




function accessGalleryForm() {
	global $tr;
	$html .= "<table cellpadding=2 cellspacing=0 border=0><tr valign=middle><form method=\"post\" name=\"galaccess\" action=\"index.php\"><td>";
	$html .= "<nobr>".$tr['ag_code']."</nobr></td><td ><input type=\"text\" name=\"access_code\" size=\"12\" class=textfield>";
	$html .= "<input type=\"hidden\" name=\"do\" value=\"photocart\">";
	$html .= "<input type=\"hidden\" name=\"action\" value=\"accessGallery\">";
	$html .= "</td><td >";
	$html .= "<input type=\"hidden\" name=\"submitit\" value=\"yes\">";
	$html .= "<input type=\"submit\" name=\"submit\" value=\" ".$tr['ag_submit']."\" class=\"submitSmall\">";
	$html .= "</td></form></tr></table>";
	return $html;
}



function siteInfo() {
	$site_infos = @mysql_query("SELECT * FROM site_info");
	if (!$site_infos) { echo( "MySQL error: " . mysql_error() . ""); exit(); }
	return $site_info = mysql_fetch_array($site_infos);
}


	function imageOptions($sp, $incart) {
	global $tr;
		print "<table align=center cellpadding=0 cellspacing=0 border=0 width=100% class=cells>";
		$selfin = explode("||", $incart['cart_size']);
		$xx = 1;
		$optsa = explode("[BREAK]", $sp['sp_finishes']);
		$opt_number = 0;
		$options = array();
		foreach($optsa AS $opts) {
			$opts = trim($opts);
			if($opts !='') {
				$opts2 = explode("\r", $opts);
				// check if required
				$optname = explode(":", $opts2[0]);

				if(trim($optname[0]) == "TITLE") {
					$sel_show = "$optname[1]";
					$start_line = 1;
				} else {
					$sel_show = "Select Options";
					$start_line = 0;
				}
				print "<tr valign=top><td>$sel_show</td><td align=right>";

					print "<select name=\"options[".$sp['sp_id']."][$opt_number]\"  class=textfield>\r";
					print "<option value=\"\">---------------------------</option>\r";
					$no = 0;

					foreach($opts2 AS $opt2) {
						$opt2 = trim($opt2);
						if(is_array($selfin)) {
							if(in_array($opt2, $selfin)) { $selected = "selected"; }
						}
				//		if($selfin[$xx] == $opt2) { $selected = "selected"; }
					if($no >= $start_line) {
								$opt2pr = explode("$", $opt2);
								if(!empty($opt2pr[0])) {
								if(!empty($opt2pr[1])) {
									$opt2pr[0] = trim($opt2pr[0]);
									$opt2pr[1] = trim($opt2pr[1]);
									print "<option value='$opt2' $selected>$opt2pr[0]  (+ ".$tr['currency']."".$opt2pr[1].")</option>\r";
								} else {
									print "<option value='$opt2' $selected>$opt2</option>\r";
								}
								unset($selected);
							}
						}
						$no++;
				}
					print "</select>\r";
					print "</td></tr>\r";
					unset($no);
					$opt_number++;
									$xx++;

				}

		}
		print "</table>";
	}


function customOptions($opt) {
	global $tr;
	$opts2 = explode("\r", $opt['opt_options']);
	print "<select name=\"options[".$opt['opt_id']."]\"  class=textfield id=\"options_".$opt['opt_id']."\">\r";
	print "<option value=\"\">------------</option>\r";
	foreach($opts2 AS $opt2) {
		$opt2 = trim($opt2);
		if($selfin[$xx] == $opt2) { $selected = "selected"; }
		$opt2pr = explode("$", $opt2);
		if(!empty($opt2pr[0])) {
			if(!empty($opt2pr[1])) {
				$opt2pr[0] = trim($opt2pr[0]);
				$opt2pr[1] = trim($opt2pr[1]);
				print "<option value=\"$opt2\" $selected>$opt2pr[0]  (Add ".$tr['currency']."".$opt2pr[1].")</option>\r";
			} else {
				print "<option value=\"$opt2\" $selected>$opt2</option>\r";
			}
			unset($selected);
		}
		$no++;
		}
	print "</select>\r";
}

function replcSpecChar($string){
	$string = str_replace("", "&aelig;", $string);
	$string = str_replace("", "&oslash;", $string);
	$string = str_replace("", "&aring;", $string);
	$string = str_replace("", "&AElig;", $string);
	$string = str_replace("", "&Oslash;", $string);
	$string = str_replace("", "&Aring;", $string);

	$string = str_replace("æ", "",$string);
	$string = str_replace("ø", "",$string);
	$string = str_replace("å", "",$string);
	$string = str_replace("Æ", "",$string);
	$string = str_replace("Ø", "",$string);
	$string = str_replace("Å", "",$string);

	$string = str_replace("á", "",$string);
	$string = str_replace("é", "",$string);
	$string = str_replace("í", "",$string);
	$string = str_replace("ó", "",$string);
	$string = str_replace("ú", "",$string);
	$string = str_replace("ñ", "",$string);




  return $string;
}



function showText($fld) {
	global $tr, $client;
	if(($_SESSION['editText'] == "1") AND (trim($_SESSION['pc_admin_login']) == "1") AND ($_REQUEST['action'] !== "orders")==true){
	$textfields = array("co_min_order", 
		"co_est_ship", 
		"ag_text",
		"rm_text",
		"li_text",
		"hp_text",
		"home_req_login",
		"home_req_under_login",
		"login_message",
		"mp_text",
		"mf_text",
		"cr_success",
		"cr_mess",
		"restricted_gal_page",
		"vi_crop",
		"pp_instructions",
		"vi_pack_in_cart",
		"pp_text",
		"gi_text",
		"ci_text",
		"co_pack_error",
		"co_descr",
		"co_ship_address_notes",
		"co_notes",
		"rp_sent",
		"reg_buy_text",
		"reg_text",
		"reg_find_text",
		"reg_create_text",
		"reg_created",
		"reg_view_page_text",
		"reg_edit_text",
		"reg_message_text",
		"invite_text",
		"dl_terms_text",
		"pp_max_pose_message",
		"pp_add_instructions",
		"gallery_info_text",
		"compare_image_text",
		"vi_add_images",
		"pp_trad_help",
		"pp_additional_dig",
		"thumb_menu_viewing",
		"pack_select_up_to_poses",
		"download_order_info",
		"pack_add_multi_notes",
		"print_credit_invalid",
		"print_credit_good",
		"num_img_text",
		"gal_date_text",
		"gal_expire_text",
		"invite_ff",
		"favs_order_all_text",
		"favs_order_all_text2",
		"gc_description",
		"gallery_has_expired",
		"pp_dig_instructions"


	);
		$d['table'] = "pc_texts";
		$d['table_id'] = "id";
		$d['table_id_val'] = $tr['id'];
		$d['table_field'] = "$fld";
		$d['current_data'] = $tr[$fld];
		if(in_array($fld,$textfields)) {
			$d['field_size'] = "5";
			$d['field_type'] = "textarea";
		} else {
			$d['field_size'] = "40";
			$d['field_type'] = "text";
		}
		$text =  editField($d);
//		$text = textForm($fld);
	} else {
		$text = nl2br($tr[$fld]);
		$text = str_replace("[ACCESS_GALLERY_FORM]", accessGalleryForm(), $text);
		$text = str_replace("[CUSTOMER_NAME]", $client['client_name'],$text);
	}
	$text = replcSpecChar($text);
	return "".$text."";
}

function editField($d) { 
	
	$html .= "</a><span id=\"editLink-".$d['table_field']."\" class=\"textEdit\" field_id=\"".$d['table_field']."\">";
	
	if(empty($d['current_data'])) { $html .="<i>Empty - edit to add</i>"; } else { $html .= nl2br($d['current_data']); } $html .="</span>";
	$html .= "<div id=\"editLink-".$d['table_field']."-click\" style=\"position: absolute;\" class=\"tooltip\">EDIT</div>";
	return $html;
 } 

 function checkDemoMode($popup) { 
	global $setup;
	if($setup['demo_mode'] == true) { 

		print "<div>&nbsp;</div>";
		print "<div id=\"demoMode\">Sorry, that function is disabled for the demo. </div>";
		print "<div class=\"pageContent\"><a href=\"javascript:window.history.back()\">Click here to go back.</a></div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		print "<div>&nbsp;</div>";
		if($popup !== true) { 
			require "admin.footer.php"; 
		}
		die("");
	}
 }

 ?>