<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
include $setup['path']."/pc_inc/product_functions.php"; 
include $setup['path']."/pc_inc/packages_functions.php"; 
include $setup['path']."/pc_inc/gallery_image_functions.php"; 
/* Min inclusion */
$dbcon = dbConnect($setup);
$site_setup = doSQL("pc_settings", "*", "");
$use_secure_logins = $site_setup['use_secure_logins'];
unset($_SESSION['color']);
unset($_SESSION['spID']);
securityCheck();
foreach($_REQUEST AS $id => $value) {
	$_REQUEST[$id] = addslashes(stripslashes(strip_tags($value)));
	$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
}

if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
require "pc_icons.php";
/* end Min inclusion */
?>
<?php
/* GET PHOTO PRICE GROUP */

$pic = doSQL("galleries", "*", " WHERE gal_id='".$_REQUEST['gal_id']."' ");
$returnval = galleryTree($pic,"pagetitle");
$main_gallery = $returnval[2];

if(empty($main_gallery)) { 
	$toplevelgallery = true;
	$main_gallery = $pic['gal_id']; 
} else {
	$main_gal = doSQL("galleries", "*, date_format(DATE_ADD(gal_expire, INTERVAL 2 HOUR), '%M %e, %Y ')  AS gal_expire_show", "WHERE gal_id='".$main_gallery."' ");
}
if($toplevelgallery == true) {
	$gal_pg = $pic['gal_pg'];
} else {
	$gal_client = $main_gal['gal_client'];
	$gal_invite = $main_gal['gal_allow_invite'];
	if(($pic['gal_pg'] == "0")OR($main_gal['gal_pg']==$pic['gal_pg'])==true) {
		$gal_pg = $main_gal['gal_pg'];
	} elseif($main_gal['gal_pg']!==$pic['gal_pg']) {		
		$gal_pg = $pic['gal_pg'];
	}

}
if(!empty($pic['pic_pg'])) {
	$gal_pg = $pic['pic_pg'];
}
if($_SESSION['pc_client_id'] > 0) {
	$client = doSQL("pc_clients", "*", "WHERE client_id='".$_SESSION['pc_client_id']."' ");
}

if($client['client_pg'] > 0) {
	$gal_pg = $client['client_pg'];
}
$pg = doSQL("price_groups", "*", "WHERE pg_id='$gal_pg' " );
if((countIt("galleries", "WHERE gal_sub_gal='".$pic['gal_id']."' ") > 0)&&($pic['gal_sub_gal'] <= 0)==true) { 
	$totals = countGalsImgs($pic['gal_id']);
	$total_images = $totals['images'];
} else { 
	$total_images = countIt("pics", "WHERE pic_gal='".$_REQUEST['gal_id']."' ");
}



if((($_SESSION['pc_client_login'] !== true) ||  ($_SESSION['pc_client_id'] == NULL )) AND ($site_setup['login_status']!=="1")==true) {
	print "<table align=center cellpadding=0 cellspacing=0 border=0 ><tr><td class=cells><span class=cart_bars_table_text>";
	print "<B>".showText("vi_add_images")."</B>";		
	$use_secure_logins = $site_setup['use_secure_logins'];
	if($use_secure_logins == 1) {
		print "<ul><li><a href=\"".$setup['secure_url']."/index.php?do=register\">".showText("vi_create_account")."</a>.";
		print "<li><a href=\"".$setup['secure_url']."/index.php?do=login\">".showText("vi_login")."</a></ul></span>";
	} else {
		print "<ul><li><a href=\"index.php?do=register\">".showText("vi_create_account")."</a>.";
		print "<li><a href=\"index.php?do=login\">".showText("vi_login")."</a></ul></span>";
	}

	print "</td></tr></table>"; 
	} else { 
?>

<!-- <div style="display: <?php print $display;?>;" id="imageInCartLink"><a href="javascript:showImageInCart('<?php print $pic['pic_id'];?>');"><?php print showText("vi_currently_in_cart");?></a></div> -->
<div style="display: none; text-align: left;" id="imageinCartContainer"><div  id="imageinCart"></div></div>
<div id="cartSuccessContainer" style="display: none;"></div>
<div id="postCart" ></div>
<div id="productListContainer">
<div id="productList" <?php if(!empty($_REQUEST['package_id'])) { print "style=\"display: none;\""; } ?>>
<?php

$gal_pg = $pg['pg_id'];
?>
<div id="otherLabels">
<?php 

$from_thumbs = 1;
$show_products = explode("\r\n",$pg['pg_layout']);
foreach($show_products AS $showit) {
	if($showit == "[PACKAGES]") { showPackagesSection(); }
//	if($showit == "[GALLERY_ITEMS]") { showGalleryItemsSection(); }
}
?>

</div>
<div>&nbsp;</div>
<div class="pageContent view_packages_window_text"><?php print showText("view_packages_window_text");?></div>
</div>
<div class="pageContent" id="backtopricelist" <?php if(!empty($_REQUEST['package_id'])) { print "style=\"display: block;\""; }  else { print "style=\"display: none;\""; } ?>><a href="javascript:showPriceList();"><?php print icon_back;?> <?php print showText("back_to_price_list");?></a></div>
<div id="addToPackage">
<?php if(!empty($_REQUEST['package_id'])) { 
	$file_included = true;
	include "pc_products_to_packages.php";
}
?>
</div>
<?php } ?>