<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
include $setup['path']."/pc_inc/gallery_image_functions.php"; 
include $setup['path']."/pc_inc/view_image_functions.php"; 
include $setup['path']."/pc_inc/product_functions.php"; 
include $setup['path']."/pc_inc/packages_functions.php"; 
$dbcon = dbConnect($setup);
securityCheck();
$site_setup = doSQL("pc_settings", "*", "");
	$get_style = $site_setup['template'];
$photo_setup = doSQL("photo_setup", "*", "");
if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
foreach($_REQUEST AS $id => $value) {
	$_REQUEST[$id] = addslashes(stripslashes(strip_tags($value)));
	$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
}
	$pic = doSQL("pics  LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*, date_format(DATE_ADD(pic_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS pic_date", " WHERE pic_id='".$_REQUEST['pic_id']."' ");
	$gallery = doSQL("galleries", "*, date_format(DATE_ADD(gal_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_date_show, date_format(DATE_ADD(gal_expire, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_expire_show", " WHERE gal_id='".$pic['pic_gal']."' ");

	$returnval = galleryTree($gallery,"pagetitle");
	$main_gallery = $returnval[2];

	if(empty($main_gallery)) { 
		$toplevelgallery = true;
		$main_gallery = $gallery['gal_id']; 
	} else {
		$main_gal = doSQL("galleries", "*, date_format(DATE_ADD(gal_expire, INTERVAL 2 HOUR), '%M %e, %Y ')  AS gal_expire_show", "WHERE gal_id='".$main_gallery."' ");
	}
$access_status = checkGalleryAccess();
if($access_status['gal_access_status'] == "expired") {
	die("no access");
}
if($access_status['gal_access_status'] == "access_form") {
	die("no access");
}


$sp = doSQL("size_price", "*", "WHERE sp_id='".$_REQUEST['sp_id']."' ");

?>


<?php

$x1      = $_REQUEST['x1'];
$y1      = $_REQUEST['y1'];
$width   = $_REQUEST['width'];
$height  = $_REQUEST['height'];
$theImage = "".$setup['path']."/".$setup['gallery_folder']."/".$gallery['gal_folder'].""."/".$pic['pic_pic'].""; 
if(!is_dir($setup['path']."/".$setup['gallery_folder']."/crops")) {
	@mkdir($setup['path']."/".$setup['gallery_folder']."/crops", 0777);
	@chmod($setup['path']."/".$setup['gallery_folder']."/crops", 0777);
}

$srcImg  = imagecreatefromjpeg($theImage);
$newImg  = imagecreatetruecolor($width, $height);

imagecopyresampled($newImg, $srcImg, 0, 0, $x1, $y1, $width, $height, $width, $height);
$cropped_image_name = "cropped-".date('ymdhis')."-".$pic['pic_pic']."";



if($gallery['gal_remove_watermark'] == "1") {
	$remove_watermark = $gallery['gal_remove_watermark'];
} else {
	$remove_watermark = $main_gal['gal_remove_watermark'];
}

$wm = doSQL("pc_watermarking", "*", "");
 if((($wm['wm_images']=="1"))AND(!empty($wm['wm_images_file']))AND($remove_watermark!=="1")==true) {
	$location = $wm['wm_images_location'];
	$overlay = $setup['path']."/".$wm['wm_images_file'];
	$w_offset = 0;
	$h_offset = 0;
	if(file_exists($overlay)) {
		$overlay = imagecreatefrompng($dir . $overlay);
		// Get the size of overlay
		$owidth = imagesx($overlay);
		$oheight = imagesy($overlay);
		 
		 if($location == "center") {
			// center
			imagecopy($newImg, $overlay, ($iwidth / 2) - (($owidth - $w_offset) / 2), ($iheight / 2)- (($oheight - $h_offset)/2), 0, 0, $owidth, $oheight);
		 } elseif($location == "bright") {
		   // bottom right
			imagecopy($newImg, $overlay, $iwidth- $owidth - $w_offset, $iheight - $oheight - $h_offset, 0, 0, $owidth, $oheight);
		 } elseif($location == "bottom") {
			// bottom center
			imagecopy($newImg, $overlay, ($iwidth / 2) - (($owidth - $w_offset) / 2), $iheight - $oheight - $h_offset, 0, 0, $owidth, $oheight);
		 } elseif($location == "bleft") {
			// bottom left
			imagecopy($newImg, $overlay, 0, $iheight - $oheight - $h_offset, 0, 0, $owidth, $oheight);

		 } elseif($location == "uright") {
		   // top right
			imagecopy($newImg, $overlay, $iwidth- $owidth - $w_offset, 0, 0, 0, $owidth, $oheight);
		 } elseif($location == "top") {
			// top center
			imagecopy($newImg, $overlay, ($iwidth / 2) - (($owidth - $w_offset) / 2), 0, 0, 0, $owidth, $oheight);
		 } elseif($location == "uleft") {
			// top left
			imagecopy($newImg, $overlay, 0, 0, 0, 0, $owidth, $oheight);
		 } else {
			imagecopy($newImg, $overlay, ($iwidth / 2) - (($owidth - $w_offset) / 2), ($iheight / 2)- (($oheight - $h_offset)/2), 0, 0, $owidth, $oheight);
		 }
		imagedestroy($overlay);
	}
 }



imagejpeg($newImg, "photos/crops/$cropped_image_name");

$id = insertSQL("pc_crops", "crop_pic='".$pic['pic_id']."', crop_url='$cropped_image_name',x1='$x1',y1='$y1', width='$width', height='$height' ");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>Cropping</title>
<script language="javascript" src="<?php if($full_url == true) { print $setup['url']."/"; } ?>js/jquery1.7.2.js" type="text/javascript"></script>
<script language="javascript" src="<?php if($full_url == true) { print $setup['url']."/"; } ?>js/photocart.js" type="text/javascript"></script>
<script language="javascript" src="<?php if($full_url == true) { print $setup['url']."/"; } ?>js/photocart7f.js" type="text/javascript"></script>
<link rel="stylesheet" href="<?php if($full_url == true) { print $setup['url']."/"; } ?><?php print "pc_style2.php?csst=".$get_style."&ipad=$ipad&mobile=$mobile&wbg=".$_REQUEST['wbg']."&pc_included=".$pc_included."";?>" type="text/css">
</head>
<body>

<?php $size= @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/crops/".$cropped_image_name.""); ?>

    <div class="pageContent"><h3><?php print $tr['_crop_your_cropped_image_'];?></h3></div>
    <div class="pageContent"><?php print $tr['_crop_review_description_'];?></div>

	<div class="pageContent" style="text-align: right; width: <?php print $size[0];?>px; margin: auto;">   
	<a href="" onClick="submitICrop('<?php print $id;?>','<?php print $_REQUEST['sp_id'];?>','<?php print MD5($id);?>','<?php print $pic['pic_id'];?>','<?php print $size[0];?>','<?php print $size[1];?>','<?php print $tr['_crop_saved_message_'];?>'); return false;"  class="submitSmall"><?php print $tr['_crop_save_'];?></a>  
	<a href="pc_crop.php?pic_id=<?php print $pic['pic_id'];?>&sp_id=<?php print $sp['sp_id'];?>&rc=<?php print MD5($id);?>&wbg=1" class="submitSmall"><?php print $tr['_recrop_image_'];?></a>   
	<a href="" onClick="closeCropping(); return false;"  class="submitSmall"><?php print $tr['_crop_cancel_'];?></a> </div>



	<div style="margin: auto; text-align: center; width: <?php print $width;?>px; height: <?php print $height;?>px;">

	<div style="width: <?php print $width;?>px;  height: <?php print $height;?>px; background: url(pcicons/loading1.gif) no-repeat center;">
			<div  id="originalImage" style="position: absolute;"><img src="<?php print "image.php?image=".$pic['pic_id']."|d||".$bw."|".$colorize."|".$color_type."|".MD5($id)."|".$newsize['width']."|".$newsize['height']."||".date('Ymdhis')."";?>" id="testImage" height="<?php print $height;?>" width="<?php print $width;?>" /></div>
				<div style="z-index: 101; position: absolute;"><img id="" src="pcicons/photo.gif" height="<?php print $height;?>" width="<?php print $width;?>"" ></div>
			</div>
	</div>
</body>
</html>