<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Cache-control: private"); 
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
include $setup['path']."/pc_inc/gallery_image_functions.php"; 
require "pc_icons.php"; 
$dbcon = dbConnect($setup);
securityCheck();
$site_setup = doSQL("pc_settings", "*", "");
$photo_setup = doSQL("photo_setup", "*", "");
if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
foreach($_REQUEST AS $id => $value) {
	$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
}
?>
<div  id="popupinner">


<script>
 $(document).ready(function(){
	$(".textEdit").each(function(i){
		var this_id = this.id;
		$("#"+this_id).bind('click', function() { editText(this_id) });
	});

 });
</script>


<script type="text/javascript">
	function setCheckedValue(radioObj, newValue) {
	if(!radioObj)
		return;
	var radioLength = radioObj.length;
	if(radioLength == undefined) {
		radioObj.checked = (radioObj.value == newValue.toString());
		return;
	}
	for(var i = 0; i < radioLength; i++) {
		radioObj[i].checked = false;
		if(radioObj[i].value == newValue.toString()) {
			radioObj[i].checked = true;
		}
	}
}
</script>

<?php
if(!function_exists(photoCartIncluded)) { die("Direct file access denied"); }


if(!empty($_POST['submitit'])) {

	foreach($_REQUEST AS $id => $value) {
		$_REQUEST[$id] = addslashes(stripslashes(strip_tags($value)));
		$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
	}

	if((empty($_REQUEST[$_REQUEST['searchby']]))AND($_REQUEST['searchby']!=="qdate")==true) {
		$message = $tr['search_empty'];
		searchForm($message);

	} else {
		if($site_setup['hide_expired_gallery'] == "1") {
			$and_expire = "   AND ((gal_expire!='0000-00-00' AND gal_expire>=CURDATE() ) OR (gal_expire='0000-00-00'))";
		}

		print "<table align=center cellpadding=2 cellspacing=0 border=0 width=100%><tr><td width=100%>";
		if($_REQUEST['searchby'] == "qtitle") {
			if(function_exists('mysql_real_escape_string')) {
				$qtitle = mysql_real_escape_string($_REQUEST['qtitle']);
			} else {
				$qtitle = $_REQUEST['qtitle'];
			}
				$gal_where['where'] = "WHERE gal_status>='1' AND gal_client!='1' $and_expire  AND gal_title LIKE  '%$qtitle%'  ";
		}
		if($_REQUEST['searchby'] == "qid") {
			if(!is_numeric($_REQUEST['qid'])) { die("this is not a number"); }

			$gal_where['where'] = "WHERE gal_status>='1' AND gal_client!='1 '$and_expire  AND gal_id='".$_REQUEST['qid']."'  ";
		}
		if($_REQUEST['searchby'] == "qdate") {
			if(!is_numeric($_REQUEST['qyear'])) { die("this is not a number"); }
			if(!is_numeric($_REQUEST['qmonth'])) { die("this is not a number"); }
			if(!is_numeric($_REQUEST['qday'])) { die("this is not a number"); }

			$gdate = "".$_REQUEST['qyear']."-".$_REQUEST['qmonth']."-".$_REQUEST['qday']."";
			$gal_where['where'] = "WHERE gal_status>='1' AND gal_client!='1 '$and_expire  AND gal_date='$gdate'   ";
		}

		print "</td></tr></table>";

		$gal_where['table'] = "galleries";
		$gal_where['select'] = "*, date_format(DATE_ADD(gal_date, INTERVAL 2 HOUR), '%M %e, %Y ')  AS gal_date, date_format(DATE_ADD(gal_expire, INTERVAL 2 HOUR), '%M %e, %Y ')  AS gal_expire_show";

		$galleries = whileSQL("".$gal_where['table']."", "".$gal_where['select']."",  "".$gal_where['where']."" );
		$tsearch = mysql_num_rows($galleries);
		if($tsearch<=0) {
			$message = $tr['search_no_results'];
			searchForm($message);
		}	else {

				print "<img src=\"pcicons/loading-page.gif\">";
				session_write_close();
				echo "<script language=javascript>";
				echo "window.open('".$setup['url']."/index.php?do=photocart&searchby=".$_REQUEST['searchby']."&qyear=".$_REQUEST['qyear']."&qmonth=".$_REQUEST['qmonth']."&qday=".$_REQUEST['qday']."&qid=".$_REQUEST['qid']."&qtitle=".$_REQUEST['qtitle']."', '_parent', '')";
				echo "</script> ";
				exit();

		}

	}
} else {
	searchForm($message);
}

?>





<?php 
function searchForm($message) {
	global $tr;
?>
	<div style="float: right; clear: right; padding: 4px;"><a href="javascript:closepopupBGContainer();"><?php print icon_close;?></a></div>
	<div class="pageContent"><h2><?php print showText('search_title');?> <?php print $gallery['gal_title'];?></h2></div>
	<div class="pageContent"><?php print showText("search_text");?></div>
	<?php if(!empty($message)) { ?>
	<div class="errorMessage"><?php print $message;?></div>
	<?php } ?>

<form method="POST" name="galsearch" action="pc_search.php"   onSubmit="return submitPopupForm('pc_search.php','galsearch');">
<?php 
	print "<table align=center cellpadding=6 cellspacing=0 border=0><tr><td>";
	print "<input type=\"radio\" name=\"searchby\" value=\"qtitle\" checked class=\"galsearch\">";
	print "</td><td>";
	print "".showText("search_name")."</td><td><input type=\"text\" name=\"qtitle\" size=\"20\" class=\"textfield galsearch\" onfocus=\"setCheckedValue(document.forms['galsearch'].elements['searchby'], 'qtitle');\">";
	print "</td></tr><tr><td>";
	print "<input type=\"radio\" name=\"searchby\" value=\"qid\" class=\"galsearch\">";
	print "</td><td>";
	print "".showText("search_id")."</td><td><input type=\"text\" name=\"qid\" size=\"4\" class=\"textfield galsearch\" onfocus=\"setCheckedValue(document.forms['galsearch'].elements['searchby'], 'qid');\" >";
	print "</td></tr><tr><td>";
	print "<input type=\"radio\" name=\"searchby\" value=\"qdate\" class=\"galsearch\">";
	print "</td><td>";
	print "".showText("search_date")." </td><td>";
	print "<table align=center border=0 cellpadding=0 cellspacing=2 border=0><tr valign=top><td>";
	print "".showText("search_month")."</td><td >".showText("search_day")."</td><td>".showText("search_year")."</td></tr>";
	print "<tr><td align=center>";
	print "<input type=\"text\" name=\"qmonth\" size=\"3\" class=\"textfield galsearch\" value=\"".date('m')."\" onfocus=\"setCheckedValue(document.forms['galsearch'].elements['searchby'], 'qdate');\">";
	print "</td><td align=center>";
	print "<input type=\"text\" name=\"qday\" size=\"3\" class=\"textfield galsearch\" value=\"".date('d')."\" onfocus=\"setCheckedValue(document.forms['galsearch'].elements['searchby'], 'qdate');\">";
	print "</td><td align=center>";
	print "<input type=\"text\" name=\"qyear\" size=\"5\" class=\"textfield galsearch\" value=\"".date('Y')."\" onfocus=\"setCheckedValue(document.forms['galsearch'].elements['searchby'], 'qdate');\">";
	print "</td></tr></table>";

	print "</td></tr></table>";
	print "<input type=\"hidden\" name=\"do\" value=\"photocart\">";
	print "<input type=\"hidden\" name=\"action\" value=\"search\">";
	print "<input type=\"hidden\" name=\"wbg\" value=\"1\" class=\"galsearch\">";
	print "</td></tr><tr><td align=center>";
	print "<input type=\"hidden\" name=\"submitit\" value=\"yes\" class=\"galsearch\">";
	print "<input type=\"submit\" name=\"submit\" value=\" ".$tr['search_button']."\" class=submit>";
	print "</form>";
}
?>
<br><br>
	<?php
	if((trim($_SESSION['pc_admin_login']) == "1") AND ($_SESSION['pc_admin'] !== NULL ) AND($_SESSION['editText'] == "1")==true) { ?>
	<hr>
	<div>Additional text that may not be visible.</div>
	<div>&nbsp;</div>
	<div>Search button: <?php print showText("search_button");?></div>
	<div>&nbsp;</div>
	<div>Search term empty: <?php print showText("search_empty");?></div>
	<div>&nbsp;</div>
	<div>No results: <?php print showText("search_no_results");?></div>
	<div>&nbsp;</div>
<?php } ?>
</div>