<?php header("Content-type: text/css"); ?>

html, body {
	margin : 0; 
	padding : 0; 
	border : 0; 
	color : <?php print font_color;?>; 
	font-family : <?php print font_family;?>,Arial,Verdana,sans-serif; 
	font-size: <?php print font_size;?>; 
	<?php if(($_REQUEST['admin_edit'] == "1")OR($_REQUEST['wbg'] == "1")==true) { ?>
	background-color: <?php print inside_bg;?> !important;
	background-image: none !important;
	<?php } else { ?>
	background-color: <?php print outside_bg;?>;
	<?php if(!empty($css['bg_image'])) { ?>
		background-image: url('<?php print $css['bg_image'];?>');
	<?php } ?>
	<?php } ?>
	height: 100%;
}

* {margin: 0;} 

#page-wrapper { 
min-height: 100%;
margin: auto;
}
li { margin-left: 16px; } 
/*  pageTitle - When someone is viewing a page or  track details this is the page title */
.pageTitle,h1 {
	font-size: <?php print page_title_size;?>;
	color: <?php print page_title;?>;
	width: 100%;
	font-weight: normal;
}
 a.pageTitle:active,h1 a ,h1 a:active { text-decoration: none; color: <?php print page_title_link;?>; }
a.pageTitle:link, a.pageTitle:visited,h1 a:link,h1 a:visited { text-decoration: none; color: <?php print page_title_link;?>; }
a.pageTitle:hover,h1 a:hover { color: <?php print page_title_hover;?>; text-decoration: underline; } 

.pageSubTitle {
	font-size: 17px;
	color: <?php print page_title;?>;
	width: 100%;
}
 a.pageSubTitle, a.pageSubTitle:active{ text-decoration: none; color: <?php print page_title_link;?>; }
a.pageSubTitle:link, a.pageSubTitle:visited { text-decoration: none; color: <?php print page_title_link;?>; }
a.pageSubTitle:hover { color: <?php print page_title_hover;?>; text-decoration: underline; } 

h2 {
	font-size: <?php print h2_size;?>;
	color: <?php print page_title;?>;
	width: 100%;
	font-weight: normal;
}
h2 a,h2 a:active{ text-decoration: none; color: <?php print page_title_link;?>; }
h2 a:link,h2 a:visited { text-decoration: none; color: <?php print page_title_link;?>; }
h2 a:hover { color: <?php print page_title_hover;?>; text-decoration: underline; } 

h3 {
	font-size: <?php print h3_size;?>;
	color: <?php print h3_color;?>;
	width: 100%;
	font-weight: bold;
}
h3 a,h3 a:active{ text-decoration: none; color: <?php print page_title_link;?>; }
h3 a:link,h3 a:visited { text-decoration: none; color: <?php print page_title_link;?>; }
h3 a:hover { color: <?php print link_color_hover;?>; text-decoration: underline; } 


a, a:active { text-decoration: none; color: <?php print link_color;?>; }
a:link, a:visited { text-decoration: none; color: <?php print link_color;?>; }
a:hover { color: <?php print link_color_hover;?>; text-decoration: underline; } 


.navagation_table { color: <?php print boxes_font; ?>; padding: 0px;  background-color: <?php print boxes; ?>; border: solid 1px <?php print boxes_borders; ?>; }
.navagation_title { color: <?php print boxes_header_text_color; ?>; font-weight: normal;  padding: 4px;  background-color: <?php print boxes_header_color; ?>; 	}
a.navagation_table, a.navagation_table:active{ text-decoration: none; color: <?php print boxes_link;?>; }
a.navagation_table:link, a.navagation_table:visited { text-decoration: none; color: <?php print boxes_link;?>; }
a.navagation_table:hover { color: <?php print boxes_link_hover;?>; text-decoration: underline; } 
.navagation_table li { margin-left: 16px; } 


.boxedContent { color: <?php print boxes_font; ?>; padding: 0px;  background-color: <?php print boxes; ?>; border: solid 1px <?php print boxes_borders; ?>; }
a.boxedContent, a.boxedContent:active{ text-decoration: none; color: <?php print boxes_link;?>; }
a.boxedContent:link, a.boxedContent:visited { text-decoration: none; color: <?php print boxes_link;?>; }
a.boxedContent:hover { color: <?php print boxes_link_hover;?>; text-decoration: underline; } 
.boxedContent li { margin-left: 16px; } 

.borderRightSide { 
	border-right: solid 1px  <?php print boxes_borders;?>;
}



.borderBottomCell { 
	border-bottom: solid 1px  <?php print boxes_borders;?>;
}


#main_container { 
	width: <?php print main_size;?>;
	margin: auto;
	background-color: <?php print inside_bg;?>;
	border: solid 0px  <?php print inside_bg_border;?>;
	<?php if(!empty($css['table_bg_image'])) { ?>
		background-image: url('<?php print $css['table_bg_image'];?>');
	<?php } ?>

}
#headerContainer {
	 width:<?php print main_size;?>;  margin-left: auto; margin-right: auto;
	 color: <?php print header_font_color;?>; 
	 background-color: <?php print header_bg;?>;
}
#header {
	 width:100%;  margin-left: auto; margin-right: auto;
}

.headerName {
	font-size: 40px;
	font-weight: bold;
	padding: 6px;
}


#leftHomePageRequireLogin { float: left; padding: 4px; width: 49%; } 
#rightHomePageRequireLogin { float: right; padding: 4px; width: 49%; } 


/* TOP FLOATING MENU - The following controls the menu that floats at the top of the page where the shopping cart link appears. */


#menu_slider {
	position: relative;
	text-align: center;
	 width:<?php print main_size;?>; 
	 margin: auto;
}

#menu_top {
	padding: 0;
	text-align: center;
	float: right;
}

#menu_top_container { 
	text-align: center;
	position: absolute;
	margin: auto;
	padding: 0;
	z-index: 15;
	list-style: none;
	white-space: nowrap;
	right: 0;
}
#menu_top #menu_item { 
	float: left;
	padding: 0px;
	margin-right: 16px;
}
#menu_top #cart_info { 
	float: right;
	padding: 10px;
	color: <?php print top_menu_text;?>;
}
#menu_top a,  #menu_top a:active { text-decoration: none; color: <?php print top_menu_link;?>;}
#menu_top a:link, #menu_top a:visited {  text-decoration: none; color: <?php print top_menu_link;?>;   }
#menu_top a:hover {  color: <?php print top_menu_link;?>; text-decoration: underline;  } 

 #cart_info { 
background-color: <?php print top_menu_bg;?>;
border: solid 1px <?php print top_menu_border;?>;
padding: 6px;
/*	width: 255px; */
}

/* END  TOP FLOATING MENU */



/* TOP MAIN MENU AREA - The following controls the main menu area */

#topMainMenuContainer {
	 width:<?php print main_size;?>;  margin-left: auto; margin-right: auto;
	background:<?php print menu_color;?>;
	border-bottom:1px solid <?php print menu_border_b;?>;
	border-top:1px solid <?php print menu_border_a;?>;
	color: <?php print menu_font_color;?>;
	z-index: 6;
} 

#topMainMenu {
	list-style:none;
	margin: 0;
	padding: 0;
	position:relative;
	z-index: 10;
	 width:100%;  margin-left: auto; margin-right: auto;
}
#topMainMenu a,  #topMainMenu a:active {   text-decoration: none; color: <?php print menu_link_color;?>;}
#topMainMenu a:link, #topMainMenu a:visited { text-decoration: none; color: <?php print menu_link_color;?>;   }
#topMainMenu a:hover {  color: <?php print menu_link_hover;?>; text-decoration: underline;  } 

#topMainMenu ul {
	line-height:30px;
	left: 0;
	margin:0;
	margin-left:6px; 
	padding-left:0.2em; 
}

#topMainMenu li {
	margin: 0;
	padding: 0;
	list-style: none;
	float: left;
}

#topMainMenu li a {	
	display: block;
	margin: 0 1px 0 0;
	padding: 6px 16px 6px 0;
	color: <?php print menu_link_color;?>;
	text-decoration: none;
}
#topMainMenu li a:hover {	 color: <?php print menu_link_hover;?>; text-decoration: underline; }


.topMainMenuItem {
	display:block;
	float:left;
	margin: 0 4px 0 0 ;
	padding:6px;
	position:relative;
	text-decoration:none;
	line-height:30px;

}
.topMainMenuItemOn {
	float:left;
	margin: 0 4px 0 0 ;
	padding:6px;
	position:relative;
	text-decoration:none;
	line-height:30px;
	z-index: 11;
}

.topMainMenuDropDown {
	color: <?php print font_color;?>;
	background-color: <?php print menu_color;?>;
	position: absolute;
	padding: 0px 4px 4px 4px;
	margin: 6px 0 0 -8px;
	z-index: 110;
	right: 0;
	min-height: 1px;

}

.topMainMenuItem:hover {
	background-color: <?php print menu_color;?>;
}
.topMainMenuLabel {
	display:block;
	float:left;
	margin:auto;
	padding:6px;
	position:relative;
	text-decoration:none;
	line-height:30px;
}

.topMainMenuStart {
	display:block;
	float:left;
	margin:auto;
	padding:6px;
	position:relative;
	text-decoration:none;
	line-height:30px;
}
.topMainMenuEnd {
	display:block;
	float:left;
	margin:auto;
	padding:6px;
	position:relative;
	text-decoration:none;
	line-height:30px;
}


#topMainMenuDropDownItem{
	padding: 6px;
	margin: 0;
	font-size: <?php print font_size;?>;
	color: <?php print boxes_borders;?>;
	text-align: left;
	border-bottom: 1px solid <?php print menu_border_b;?>;
	line-height: 13px;
}
#topMainMenuDropDownItem a,  #topMainMenuDropDownItem a:active { text-decoration: none; color: <?php print menu_link_color;?>;}
#topMainMenuDropDownItem a:link, #topMainMenuDropDownItem a:visited {  text-decoration: none; color: <?php print menu_link_color;?>;   }
#topMainMenuDropDownItem a:hover {  color: <?php print menu_link_hover;?>; text-decoration: underline;  } 

/* END TOP MAIN MENU AREA  */


#contentUnderMenu { 
	padding: 6px; 
}



/* MAIN CONTENT AREA - The following controls the main content on the pages */

.pageContent { 
	padding: 4px;
}

.pageContentBold { 
	font-weight: bold;
	padding: 4px;
}

/* errorMessage - This is when an error is displayed */
.errorMessage {
	background-color: <?php print error_message_bg;?>;
        border: solid 1px <?php print error_message_border;?>;
        font-weight: normal;
        color: <?php print error_message_text;?>;
		padding: 4px;
	clear: both;
}
.error {
	color: #490000;
}

/* successMessage - This is when a success message is displayed */
.successMessage {
	background-color: <?php print success_message_bg;?>;
        border: solid 1px <?php print success_message_border;?>;
        font-weight: normal;
        color: <?php print success_message_text;?>;
		padding: 4px;
	clear: both;
}

.successMessage a,  .successMessage a:active {text-decoration: none; color: <?php print success_message_text;?>; }
.successMessage a:link, .successMessage a:visited {text-decoration: none; color: <?php print success_message_text;?>;   }
.successMessage a:hover {color: <?php print success_message_text;?>; text-decoration: underline;   } 


.storeClosed {
	background-color: #EDE5AB;
        border: solid 1px #BAB066;
        font-weight: normal;
        color: #000000;
		padding: 4px;
}
#earlyBirdSpecial{
	background-color: <?php print special_message_bg;?>;
    border: solid 1px <?php print special_message_border;?>;
    font-weight: normal;
    color: <?php print special_message_text;?>;
	padding: 4px;
	text-align: center;
	clear: both;
}
#specialMessage{
	background-color: <?php print special_message_bg;?>;
    border: solid 1px <?php print special_message_border;?>;
    font-weight: normal;
    color: <?php print special_message_text;?>;
	padding: 4px;
	text-align: center;
	clear: both;
}
.specialMessage{
	background-color: <?php print special_message_bg;?>;
    border: solid 1px <?php print special_message_border;?>;
    font-weight: normal;
    color: <?php print special_message_text;?>;
	padding: 4px;
	text-align: left;
	clear: both;
}
.specialMessage a,  .specialMessage a:active {text-decoration: none; color: <?php print special_message_text;?>; }
.specialMessage a:link, .specialMessage a:visited {text-decoration: none; color: <?php print special_message_text;?>;   }
.specialMessage a:hover {color: <?php print special_message_text;?>; text-decoration: underline;   } 
