<?php
include "setup.php";
session_start();
error_reporting(E_ALL ^ E_NOTICE);
header("Expires: Mon, 26 Jul 1990 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");
header('Content-Type: text/html; charset=iso-8859-1');
ob_start(); 
include $setup['path']."/pc_inc/functions.php"; 
include $setup['path']."/pc_inc/pc_functions.php"; 
include $setup['path']."/pc_inc/gallery_image_functions.php"; 
require "pc_icons.php"; 
$dbcon = dbConnect($setup);
securityCheck();
$site_setup = doSQL("pc_settings", "*", "");
$photo_setup = doSQL("photo_setup", "*", "");
if(!empty($_SESSION['pc_language'])) {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$_SESSION['pc_language']."' ");
} else {
	$tr = doSQL("pc_texts LEFT JOIN pc_texts2 ON pc_texts.id=pc_texts2.lang_id ", "*", "WHERE id='".$site_setup['default_language']."' ");
}
if($_REQUEST['viewGallery']!=="favs") { 
	if(!is_numeric($_REQUEST['viewGallery'])) { die(); }
	
	$gallery = doSQL("galleries", "*", "WHERE gal_id='".$_REQUEST['viewGallery']."' ");
	if(empty($gallery['gal_id'])) { die("no gallery to display"); } 
	$gallery = doSQL("galleries", "*, date_format(DATE_ADD(gal_expire, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_expire_show, date_format(DATE_ADD(gal_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_date_show", " WHERE gal_id='".$gallery['gal_id']."' ");
	$returnval = galleryTree($gallery,"pagetitle");
	$main_gallery = $returnval[2];
	if(empty($main_gallery)) { 
		$toplevelgallery = true;
		$main_gallery = $gallery['gal_id'];
		$gal_client = $gallery['gal_client'];
		$gal_expire_show = $gallery['gal_expire_show'];
		$gal_date_show = $gallery['gal_date_show'];
		$gal_date = $gallery['gal_date'];
		$gal_eb_through = $gallery['gal_eb_through'];
		$gal_status = $gallery['gal_status'];
		$gal_eb_dis_type = $gallery['gal_eb_dis_type'];
		$gal_eb_amount = $gallery['gal_eb_amount'];
		$gal_eb_min = $gallery['gal_eb_min'];
		$gal_eb_use_default = $gallery['gal_eb_use_default'];

		$gal_discount = $gallery['gal_discount'];
		$gal_pg = $gallery['gal_pg'];
		$gal_expire = $gallery['gal_expire'];
		$gal_style = $gallery['gal_style'];
		$gal_invite = $gallery['gal_allow_invite'];
		$gal_search = $gallery['gal_search'];
		$gal_under = $gallery['gal_under'];
		$gal_disble_fb = $gallery['gal_disable_fb'];
	} else {
		$mg = doSQL("galleries", "*, date_format(DATE_ADD(gal_date, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_date_show, date_format(DATE_ADD(gal_expire, INTERVAL 0 HOUR), '".$site_setup['date_format']." ')  AS gal_expire_show", "WHERE gal_id='$main_gallery' ");
		$gal_client = $mg['gal_client'];
		$gal_expire = $mg['gal_expire'];
		$gal_date = $mg['gal_date'];
		$gal_eb_through = $mg['gal_eb_through'];
		$gal_status = $mg['gal_status'];
		$gal_eb_dis_type = $mg['gal_eb_dis_type'];
		$gal_eb_amount = $mg['gal_eb_amount'];
		$gal_eb_min = $mg['gal_eb_min'];
		$gal_eb_use_default = $mg['gal_eb_use_default'];

		$gal_discount = $mg['gal_discount'];
		$gal_expire_show = $mg['gal_expire_show'];
		$gal_date_show = $mg['gal_date_show'];
		$gal_invite = $mg['gal_allow_invite'];
		$gal_search = $mg['gal_search'];
		if(!empty($gallery['gal_style'])) {
			$gal_style = $gallery['gal_style'];
		} else {
			$gal_style = $mg['gal_style'];
		}

		$gal_pg = $mg['gal_pg'];
		$gal_under = $mg['gal_under'];
		$gal_disble_fb = $mg['gal_disable_fb'];

	}
}
foreach($_REQUEST AS $id => $value) {
	if(!is_array($_REQUEST[$id])) { 
		if(!empty($value)) { 
			$_REQUEST[$id] = addslashes(stripslashes(strip_tags($value)));
			$_REQUEST[$id] = sql_safe("".$_REQUEST[$id]."");
		}
	}
}
$pics_where = " WHERE pics.pic_gal='".$gallery['gal_id']."' ";
if($_REQUEST['viewGallery'] == "favs") { 
	$total_images = countIt("pc_favs, pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id",  "WHERE pc_favs.fav_client='".$_SESSION['pc_client_id']."' AND pics.pic_id=pc_favs.fav_pic ORDER BY pics.pic_id ASC");

} else { 
	$total_images = countIt("pics", "WHERE pic_gal='".$gallery['gal_id']."'");
}

if($gallery['perrow'] > 0) {
	$perRow = $gallery['perrow'];
} else {
	$perRow = $photo_setup['perrow'];
}
if($gallery['perpage'] > 0) {
	$perCols = $gallery['perpage'];
} else {
	$perCols = $photo_setup['thumbs_per_page'];
}
if(empty($_REQUEST['page'])) {
	$vp = "1";
} else {
	$vp = $_REQUEST['page'];
}
$per_page = $perCols;
$limit_page = (($vp - 1) * $per_page);
$x = 1;
$NPvars = array("do=photocart", "viewGallery=".$gallery['gal_id']."");
$x = 1;


if(!empty($_REQUEST['q'])) {
	$ret = gallerySearchQ($main_gallery,"".$gallery['gal_id']."");

	$total_images = $ret['total_results'];
	$and_q = $ret['and_q'];
	if($_REQUEST['ingals']>0) {
		$pics_where  = $ret['pics_where'];
	}
//	print "<li>$pics_where - main gallery: $main_gallery";
	$res = str_replace("[TOTAL_IMAGES]", $total_images, $tr['search_results']);
	$res = str_replace("[SEARCH_TERM]", stripslashes($_REQUEST['q']),$res);
}
// print "<h1>main gallery: ".$main_gallery." pics where: $pics_where </h1>";

$IC = 1;
$thumb_nails = array();
$max_size = 0;
if((countIt("galleries", "WHERE gal_sub_gal='".$gallery['gal_id']."' ")>0)AND($gallery['gal_sub_gal']=="0")AND($total_images == 1)AND(empty($_REQUEST['q']))==true) { $galHome = true; $limit_page = 0; $per_page = 0; } 
?>
<script>
 $(document).ready(function(){
	<?php if(($_SESSION['ipad']!== true)&&($_SESSION['mobile'] !== true)==true) { ?>
 	 mytips(".tip","tooltip");
	 myenlarge(".enlarge","tooltip");
	<?php } ?>
	var elems = $(".thumbnail");
	var lastID = elems.length - 1;
	$(".thumbnail").each(function(i){
		var this_id = this.id;
       	var this_src =  $("#"+this_id).attr("src"); // width from the img src tag ww
		var image = new Image();
		image.onload = function() {
		$("#"+this_id).fadeIn('fast', function() {
      });
	};
	image.src =this_src;
      }).promise().done( function(){ 
		
	} );
 });
</script>
<?php if($vp == 1) { ?>
<div id="page-1" style="float: left;"></div>
<?php } ?>

<?php
	if($vp > 1) { 
		$position = ($vp- 1) * $per_page;
	} else { 
		$position = 0;
	}
if($_REQUEST['viewGallery'] == "favs") { 
	$pics = whileSQL("pc_favs, pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*", "WHERE pc_favs.fav_client='".$_SESSION['pc_client_id']."' AND pics.pic_id=pc_favs.fav_pic ORDER BY pics.pic_id ASC  LIMIT $limit_page, $per_page");
} else { 
	$pics = whileSQL("pics LEFT JOIN galleries ON pics.pic_gal=galleries.gal_id", "*, date_format(DATE_ADD(pic_date, INTERVAL ".$site_setup['time_diff']." HOUR), '".$site_setup['date_format']." ')  AS pic_date",  "$pics_where $and_q  ORDER BY pic_order ASC LIMIT $limit_page, $per_page" );
}
while($pic = mysql_fetch_array($pics)) {
	$size = @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$pic['gal_folder']."/".$pic['pic_th'].""); 
//		$dsize = @GetImageSize("".$setup['path']."/".$setup['gallery_folder']."/".$pic['gal_folder']."/".$pic['pic_pic'].""); 
	if($size[0] > $max_size_width) { $max_size_width = $size[0]; } 
	if($size[1] > $max_size_height) { $max_size_height = $size[1]; } 
	array_push($thumb_nails,array("pic_id"=>$pic['pic_id'],"pic_th" => $pic['pic_th'],"pic_pic" => $pic['pic_pic'],"pic_gal" => $pic['pic_gal'],"width" => $size[0],"height" => $size[1],"dwidth" => $dsize[0],"dheight" => $dsize[1],"pic_org" => $pic['pic_org'],"dis" => $pic['pic_pic'],"bg_color" => $pic['pic_bg_color'],"gal_pg" => $pic['gal_pg'],"border_in" => $pic['pic_border_in_color'],"border_out" => $pic['pic_border_out_color'],"gal_folder" => $pic['gal_folder'], "gal_sub_gal" => $pic['gal_sub_gal'],"pic_title" => $pic['pic_title'],"gal_free_image" => $pic['gal_free_image'],"gal_free_image_size" => $pic['gal_free_image_size'],"position" => $position,"gal_free_image_watermark" => $pic['gal_free_image_watermark']));
		$position++;
}

$this_in_array = 0;
$total_thumbs = count($thumb_nails);
if($max_size_width < 130) { $max_size_width = 130; } 


$pi = checkAddToPackageThumbnail();
$show_package_icon = $pi['show_icon'];
foreach($thumb_nails AS $pic) {

	print "<div style=\"width: ".($max_size_width + 20)."px; height: ".($max_size_height + 60)."px; margin: auto; display: inline; \" id=\"thumbContain-".$pic['pic_id']."\">";

	print "<div  class=\"thumbContainer\"   style=\" bottom: 0; left: 8px;  display: inline-block; *display:inline; zoom: 1; width: ".($max_size_width + 20)."px; height: ".($max_size_height + 60)."px; float: none;\">";
	print "<div style=\"display: block; position: relative; bottom: 0;height: ".($max_size_height + 60)."px;text-align: center; \"><div style=\"width: ".($max_size_width + 20)."px; position: absolute; bottom: 0;text-align: center; margin: auto; display: block;\">".displayGalleryThumbnail($pic)."</div></div>";
//	print "<center><img src=\"".$setup['gallery_folder']."/".$pic[gal_folder]."/".$pic[pic_th]."\" height=\"".$thumb[height]."\" width=\"".$thumb[width]."\" border=\"0\"></center>";
	echo "</div></div>";
	$x = 1;
	$IC++;
}
?>


<?php
if($per_page > 0) { 
	if(($total_images / $per_page) > $vp) { ?>
	<div id="page-<?php print $vp + 1;?>" style="float: left;"></div>
	<?php } 
}
?>